## trilinos 12.6.4

=== CMakeLists.txt ===
# @HEADER
# ************************************************************************
#
#            Trilinos: An Object-Oriented Solver Framework
#                 Copyright (2001) Sandia Corporation
#
#
# Copyright (2001) Sandia Corporation. Under the terms of Contract
# DE-AC04-94AL85000, there is a non-exclusive license for use of this
# work by or on behalf of the U.S. Government.  Export of this program
# may require a license from the United States Government.
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# NOTICE:  The United States Government is granted for itself and others
# acting on its behalf a paid-up, nonexclusive, irrevocable worldwide
# license in this data to reproduce, prepare derivative works, and
# perform publicly and display publicly.  Beginning five (5) years from
# July 25, 2001, the United States Government is granted for itself and
# others acting on its behalf a paid-up, nonexclusive, irrevocable
# worldwide license in this data to reproduce, prepare derivative works,
# distribute copies to the public, perform publicly and display
# publicly, and to permit others to do so.
#
# NEITHER THE UNITED STATES GOVERNMENT, NOR THE UNITED STATES DEPARTMENT
# OF ENERGY, NOR SANDIA CORPORATION, NOR ANY OF THEIR EMPLOYEES, MAKES
# ANY WARRANTY, EXPRESS OR IMPLIED, OR ASSUMES ANY LEGAL LIABILITY OR
# RESPONSIBILITY FOR THE ACCURACY, COMPLETENESS, OR USEFULNESS OF ANY
# INFORMATION, APPARATUS, PRODUCT, OR PROCESS DISCLOSED, OR REPRESENTS
# THAT ITS USE WOULD NOT INFRINGE PRIVATELY OWNED RIGHTS.
#
# ************************************************************************
# @HEADER

#
# A) Define your project name and set up major project options
#

# To be safe, define your minimum CMake version.  This may be newer than the
# min required by TriBITS.
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.11 FATAL_ERROR)

# Must set the project name as a variable at very beginning before including anything else
# We set the project name in a separate file so CTest scripts can use it.
INCLUDE(${CMAKE_SOURCE_DIR}/ProjectName.cmake)

# CMake requires that you declare the CMake project in the top-level file and
# not in an include file :-(
PROJECT(${PROJECT_NAME} NONE)

# Set default C++ standard to C++11
SET(Trilinos_ENABLE_CXX11_DEFAULT ON)

#
# B) Pull in the TriBITS system and execute
#

INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/cmake/tribits/TriBITS.cmake)


# Make Trilinos create <Package>Config.cmake files by default
SET(${PROJECT_NAME}_ENABLE_INSTALL_CMAKE_CONFIG_FILES_DEFAULT ON)
# Make Trilinos set up CPack support by default
SET(${PROJECT_NAME}_ENABLE_CPACK_PACKAGING_DEFAULT ON)
# Don't allow disabled subpackages to be excluded from tarball
SET(${PROJECT_NAME}_EXCLUDE_DISABLED_SUBPACKAGES_FROM_DISTRIBUTION_DEFAULT FALSE)

# Do all of the processing for this Tribits project
TRIBITS_PROJECT()

# Install TriBITS so that other projects can use it.
ADVANCED_SET(${PROJECT_NAME}_INSTALL_TriBITS ON CACHE BOOL
  "If ture, install TriBITS into <lib-install-dir>/cmake/tribits/")
IF (${PROJECT_NAME}_INSTALL_TriBITS)
  ASSERT_DEFINED(Trilinos_SOURCE_DIR)
  ASSERT_DEFINED(${PROJECT_NAME}_INSTALL_LIB_DIR)
  INSTALL(
    DIRECTORY "${Trilinos_SOURCE_DIR}/cmake/tribits"
    DESTINATION "${${PROJECT_NAME}_INSTALL_LIB_DIR}/cmake"
    )
ENDIF()

=== packages/amesos/CMakeLists.txt ===


#
# A) Define the package
#

TRIBITS_PACKAGE(Amesos)

#
# B) Set up package-specific options
#

# if using SuperLUDist, must also link in ParMETIS for some reason
IF(${PACKAGE_NAME}_ENABLE_SuperLUDist AND NOT ${PACKAGE_NAME}_ENABLE_ParMETIS)
  MESSAGE(FATAL_ERROR "The Amesos support for the SuperLUIDist TPL requires the ParMETIS TPL.  Either disable Amesos SuperLUDist support or enable the ParMETIS TPL.")
ENDIF()

# if using parallel MUMPS, must also link in scalapack and BLACS

IF(${PACKAGE_NAME}_ENABLE_MUMPS AND ${PACKAGE_NAME}_ENABLE_MPI AND NOT ${PACKAGE_NAME}_ENABLE_SCALAPACK)
  MESSAGE(FATAL_ERROR "The Amesos support for parallel MUMPS requires SCALAPACK.")
ENDIF()

IF(${PACKAGE_NAME}_ENABLE_MUMPS AND ${PACKAGE_NAME}_ENABLE_MPI AND NOT ${PACKAGE_NAME}_ENABLE_BLACS)
  MESSAGE(FATAL_ERROR "The Amesos support for parallel MUMPS requires BLACS.")
ENDIF()

## Most of the options below are bogus.  The handling of TPLs is done
## through the dependencies file.  This needs to be cleaned up. I'm
## leaving them for now so that we have a list of all options.  They
## will be removed as correct TPL support is added.

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_DSCPACK
  HAVE_AMESOS_DSCPACK
  "Enable DSCPACK functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_MC64
  HAVE_AMESOS_MC64
  "Enable MC64 functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_KLU
  HAVE_AMESOS_KLU
  "Enable KLU (Tim Davis's Files)."
  ON )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PARDISO
  HAVE_AMESOS_PARDISO
  "Enable PARDISO functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PARDISO_MKL
  HAVE_AMESOS_PARDISO_MKL
  "Enable PARDISO functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PARAKLETE
  HAVE_AMESOS_PARAKLETE
  "Enable PARAKLETE functionality."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_LAPACK
  HAVE_AMESOS_LAPACK
  "Enable LAPACK functionality."
  ON )
  
# ...

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

TRIBITS_EXCLUDE_FILES(
  doc/AmesosOverview
  doc/PARA06
  example/RunParaklete.cpp
  example/Thyra_AmesosLinearOpWithSolveFactory.cpp
  example/pk.h
  example/run_pk.c
  example/simpleStratimikosSolve.cpp
  example/simpleStratimikosSolve.hpp
  example/stratimikos_example.cpp
  src/Amesos_BTF.h
  src/Amesos_Component.h
  src/Amesos_Merikos.h
  src/Amesos_BTF.h
  src/SuiteSparse/CAMD/Source/amesos_camd_1.c
  src/SuiteSparse/CAMD/Source/amesos_camd_aat.c
  src/SuiteSparse/CAMD/Source/amesos_camd_control.c
  src/SuiteSparse/CAMD/Source/amesos_camd_defaults.c
  src/SuiteSparse/CAMD/Source/amesos_camd_dump.c
  src/SuiteSparse/CAMD/Source/amesos_camd_info.c
  src/SuiteSparse/CAMD/Source/amesos_camd_order.c
  src/SuiteSparse/CAMD/Source/amesos_camd_preprocess.c
  src/SuiteSparse/CAMD/Source/amesos_camd_valid.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_amd.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_analyze.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_colamd.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_etree.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_factorize.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_postorder.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_rcond.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_resymbol.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_rowcolcounts.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_rowfac.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_solve.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_spsolve.c
  src/SuiteSparse/CHOLMOD/Cholesky/amesos_t_cholmod_rowfac.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_aat.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_add.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_band.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_change_factor.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_copy.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_dense.c
  src/SuiteSparse/CHOLMOD/Core/amesos_cholmod_factor.c
  src/SuiteSparse/CHOLMOD/Partition/amesos_cholmod_camd.c
  src/SuiteSparse/CHOLMOD/Partition/amesos_cholmod_ccolamd.c
  src/SuiteSparse/CHOLMOD/Partition/amesos_cholmod_csymamd.c
  src/SuiteSparse/CHOLMOD/Partition/amesos_cholmod_metis.c
  src/SuiteSparse/CHOLMOD/Partition/amesos_cholmod_nesdis.c
  src/src-repository
  src/stamp-h.in
  test/TestOptions/Dummy
  test/Test_Basic/NotQuiteDense.triU
  test/Test_Performance/In_Test_UmfpackPerformance.csh
  test/scripts/daily/mpi/TestBasic.sh
  test/scripts/daily/serial/TestAmesos.sh
  )

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/muelu/CMakeLists.txt ===
INCLUDE(CombinedOption)

#
# A) Define the package
#

TRIBITS_PACKAGE(MueLu ENABLE_SHADOWING_WARNINGS)

#
# B) Set up package-specific options
#
IF ((CMAKE_CXX_COMPILER_ID MATCHES "GNU") AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "4.7"))
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-local-typedefs")
ENDIF()

IF (NOT ${PACKAGE_NAME}_ENABLE_Epetra AND NOT ${PACKAGE_NAME}_ENABLE_Tpetra)
  MESSAGE(FATAL_ERROR "Neither Epetra nor Tpetra are enabled.  MueLu requires at least one of them to be enabled.")
ENDIF()

# JJH: pulled this logic from Tpetra.  Comments below about CUDA are from Tpetra developers.
# This is redundant, since MueLu also requires Kokkos, and Kokkos requires C++11.
# "I left a special case for CUDA because I'm not sure whether TriBITS
# counts C++11 as enabled in that case; please feel free to revise if
# you know better."
ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_CXX11)
ASSERT_DEFINED(TPL_ENABLE_CUDA)
IF (NOT ${PROJECT_NAME}_ENABLE_CXX11 AND NOT TPL_ENABLE_CUDA)
  MESSAGE(FATAL_ERROR "MueLu requires that C++11 support in Trilinos be enabled.  This should happen automatically if your compiler is C++11 compliant.")
ENDIF ()

# The following Tribits macro sets MueLu_ENABLE_EXPLICIT_INSTANTIATION
# to be true if Trilinos_ENABLE_EXPLICIT_INSTANTIATION is true.
TRIBITS_ADD_EXPLICIT_INSTANTIATION_OPTION()
IF (${PACKAGE_NAME}_ENABLE_EXPLICIT_INSTANTIATION AND NOT ${PACKAGE_NAME}_ENABLE_Tpetra)
  GLOBAL_SET(${PACKAGE_NAME}_ENABLE_EXPLICIT_INSTANTIATION  OFF)
  GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_EXPLICIT_INSTANTIATION OFF)
  MESSAGE(STATUS "Disabling MueLu explicit template instantation (ETI) because Tpetra is disabled.")
ENDIF()
TRIBITS_ADD_DEBUG_OPTION()
TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

IF (${PACKAGE_NAME}_ENABLE_Epetra AND NOT ${PACKAGE_NAME}_ENABLE_EpetraExt)
  MESSAGE(FATAL_ERROR "You have enabled Epetra, but not EpetraExt. MueLu requires that either both are enabled, or both are disabled. Please either disable Epetra, or enable EpetraExt.")
ENDIF()

# Disable Ifpack2 if Tpetra is off
IF (NOT ${PACKAGE_NAME}_ENABLE_Tpetra)
  SET(${PACKAGE_NAME}_ENABLE_Ifpack2 OFF)
  GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_IFPACK2 OFF)
ENDIF ()

# Enable timer synchronization via barriers
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_TIMER_SYNCHRONIZATION
  HAVE_${PACKAGE_NAME_UC}_TIMER_SYNCHRONIZATION
  "Enable timer synchronization in MueLu via barriers."
  NO)

IF (${PACKAGE_NAME}_ENABLE_TIMER_SYNCHRONIZATION)
  MESSAGE(STATUS "Enabling timer synchronization")
ENDIF ()

# Enable experimental code
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_Experimental
  HAVE_${PACKAGE_NAME_UC}_EXPERIMENTAL
  "Enable experimental code."
  NO)
IF (${PACKAGE_NAME}_ENABLE_Experimental AND NOT Xpetra_ENABLE_Experimental)
  MESSAGE(FATAL_ERROR "Option MueLu_ENABLE_Experimental=ON requires Xpetra_ENABLE_Experimental=ON.")
ENDIF ()

IF (${PACKAGE_NAME}_ENABLE_Experimental)
  MESSAGE(STATUS "Enabling MueLu experimental code")
ENDIF()

# Enable broken tests
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_BROKEN_TESTS
  HAVE_${PACKAGE_NAME_UC}_BROKEN_TESTS
  "Enable broken code."
  NO)

# Memory testing
IF (${PACKAGE_NAME}_ENABLE_MEMORY_TESTING)
  SET(MUELU_VALGRIND_TESTING YES)
ELSE()
  SET(MUELU_VALGRIND_TESTING NO)
ENDIF()

# Profiling
TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PROFILING
  HAVE_${PACKAGE_NAME_UC}_PROFILING
  "Enable detailed timing and memory profiling of MueLu."
  OFF)

IF (${PACKAGE_NAME}_ENABLE_PROFILING)
  MESSAGE(STATUS "Enabling MueLu profiling code")
ENDIF()

# Profiling (expert users only. There is no TPL for Google Perftools)
TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_GOOGLE_PERFTOOLS
  HAVE_${PACKAGE_NAME_UC}_GOOGLE_PERFTOOLS
  "Enable detailed memory profiling using Google Perftools."
  OFF)

# Boost
# We don't actually need this option, but boost is not *really* needed, and
# I really want to hide unnecessary warnings
TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_Boost_for_real
  HAVE_${PACKAGE_NAME_UC}_BOOST_FOR_REAL
  "Enable Boost"
  OFF)

# Define option to enable code that is refactored to use Kokkos
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_Kokkos_Refactor
  HAVE_${PACKAGE_NAME_UC}_KOKKOS_REFACTOR
  "Enable MueLu code refactored to use Kokkos."
  NO)

# Define HAVE_MUELU_STRATIMIKOS if Stratimikos package is enabled
ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_Stratimikos)
GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_STRATIMIKOS ${${PACKAGE_NAME}_ENABLE_Stratimikos})

# Explicit instantiation options:
# - MueLu_ENABLE_EXPLICIT_INSTANTIATION
# - Enabling/disabling of scalar/ordinal types is controlled by Tpetra

IF(${PACKAGE_NAME}_ENABLE_EXPLICIT_INSTANTIATION)

  # <double, int, int>
  # Examples and tests need at least this one, also if Epetra is enabled
  IF(Tpetra_INST_DOUBLE AND Tpetra_INST_INT_INT)
    GLOBAL_SET(${PACKAGE_NAME}_INST_DOUBLE_INT_INT ON)
    GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_INST_DOUBLE_INT_INT ON)
  ELSE()
    GLOBAL_SET(${PACKAGE_NAME}_INST_DOUBLE_INT_INT OFF)
    GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_INST_DOUBLE_INT_INT OFF)
  ENDIF()

  #IF(${PACKAGE_NAME}_ENABLE_EXAMPLES OR ${PACKAGE_NAME}_ENABLE_TESTS)
  #  IF (NOT ${PACKAGE_NAME}_INST_DOUBLE_INT_INT)
  #    MESSAGE(FATAL_ERROR "Error: MueLu examples and tests needs explicit template instantation with <double, int, int>. Turn on the options Tpetra_INST_DOUBLE and Tpetra_INST_INT_INT or disable examples and tests.")
  #  ENDIF()
  #ENDIF()

  #IF(${PACKAGE_NAME}_ENABLE_Epetra)
  #  IF (NOT ${PACKAGE_NAME}_INST_DOUBLE_INT_INT)
  #    MESSAGE(FATAL_ERROR "Error: MueLu needs explicit template instantation with <double, int, int> when enabling Epetra. Turn on the options Tpetra_INST_DOUBLE and Tpetra_INST_INT_INT or disable Epetra.")
  #  ENDIF()
  #ENDIF()

  # <double, int, long>
  IF(Tpetra_INST_DOUBLE AND Tpetra_INST_INT_LONG)
    GLOBAL_SET(${PACKAGE_NAME}_INST_DOUBLE_INT_LONGINT ON)
    GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_INST_DOUBLE_INT_LONGINT ON)
  ELSE()
    GLOBAL_SET(${PACKAGE_NAME}_INST_DOUBLE_INT_LONGINT OFF)
    GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_INST_DOUBLE_INT_LONGINT OFF)
  ENDIF()


  # <double, int, long long int>
  IF(Tpetra_INST_DOUBLE AND Tpetra_INST_INT_LONG_LONG)
    GLOBAL_SET(${PACKAGE_NAME}_INST_DOUBLE_INT_LONGLONGINT ON)
    GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_INST_DOUBLE_INT_LONGLONGINT ON)
  ELSE()
    GLOBAL_SET(${PACKAGE_NAME}_INST_DOUBLE_INT_LONGLONGINT OFF)
    GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_INST_DOUBLE_INT_LONGLONGINT OFF)
  ENDIF()

  # <complex, int, int>
  IF(Tpetra_INST_COMPLEX_DOUBLE AND Tpetra_INST_INT_INT)
    GLOBAL_SET(${PACKAGE_NAME}_INST_COMPLEX_INT_INT ON)
    GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_INST_COMPLEX_INT_INT ON)
  ELSE()
    GLOBAL_SET(${PACKAGE_NAME}_INST_COMPLEX_INT_INT OFF)
    GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_INST_COMPLEX_INT_INT OFF)
  ENDIF()

  # <float, int, int>
  IF(Tpetra_INST_FLOAT AND Tpetra_INST_INT_INT)
    GLOBAL_SET(${PACKAGE_NAME}_INST_FLOAT_INT_INT ON)
    GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_INST_FLOAT_INT_INT ON)
  ELSE()
    GLOBAL_SET(${PACKAGE_NAME}_INST_FLOAT_INT_INT OFF)
    GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_INST_FLOAT_INT_INT OFF)
  ENDIF()

  MESSAGE(STATUS "${PACKAGE_NAME} ETI support enabled")
  MESSAGE(STATUS "<float,   int, int>       : ${${PACKAGE_NAME}_INST_FLOAT_INT_INT}")
  MESSAGE(STATUS "<double,  int, int>       : ${${PACKAGE_NAME}_INST_DOUBLE_INT_INT}")
  MESSAGE(STATUS "<double,  int, long>      : ${${PACKAGE_NAME}_INST_DOUBLE_INT_LONGINT}")
  MESSAGE(STATUS "<double,  int, long long> : ${${PACKAGE_NAME}_INST_DOUBLE_INT_LONGLONGINT}")
  MESSAGE(STATUS "<complex, int, int>       : ${${PACKAGE_NAME}_INST_COMPLEX_INT_INT}")

  # If Tpetra is enabled, determine which Nodes are used
  IF (${PACKAGE_NAME}_ENABLE_Tpetra)
    GLOBAL_SET (HAVE_${PACKAGE_NAME_UC}_SERIAL  ${Tpetra_INST_SERIAL})
    GLOBAL_SET (HAVE_${PACKAGE_NAME_UC}_PTHREAD ${Tpetra_INST_PTHREAD})
    GLOBAL_SET (HAVE_${PACKAGE_NAME_UC}_OPENMP  ${Tpetra_INST_OPENMP})
    GLOBAL_SET (HAVE_${PACKAGE_NAME_UC}_CUDA    ${Tpetra_INST_CUDA})
  ENDIF()
  IF (${PACKAGE_NAME}_ENABLE_Epetra)
    # If Epetra is active, always activate SerialNode
    GLOBAL_SET (HAVE_${PACKAGE_NAME_UC}_SERIAL ON)
  ENDIF ()
  MESSAGE(STATUS "HAVE_${PACKAGE_NAME_UC}_SERIAL       : ${HAVE_${PACKAGE_NAME_UC}_SERIAL}")
  MESSAGE(STATUS "HAVE_${PACKAGE_NAME_UC}_PTHREAD      : ${HAVE_${PACKAGE_NAME_UC}_PTHREAD}")
  MESSAGE(STATUS "HAVE_${PACKAGE_NAME_UC}_OPENMP       : ${HAVE_${PACKAGE_NAME_UC}_OPENMP}")
  MESSAGE(STATUS "HAVE_${PACKAGE_NAME_UC}_CUDA         : ${HAVE_${PACKAGE_NAME_UC}_CUDA}")
ELSE()
  # ETI is turned off

  # If Epetra only is enabled, ETI is off by default. We have to make sure that
  # the HAVE_MUELU_SERIAL variable is set such that the IfpackSmoother and other
  # purely Epetra-related routines are enabled properly
  IF (${PACKAGE_NAME}_ENABLE_Epetra)
    # If Epetra only is active, only activate SerialNode by default
    GLOBAL_SET (HAVE_${PACKAGE_NAME_UC}_SERIAL  ON)
  ENDIF()
ENDIF()

# HAVE_MUELU_COMPLEX=ON iff:
# - Teuchos_ENABLE_COMPLEX=ON and Explicit Instantiation = OFF
# or
# - HAVE_MUELU_INST_COMPLEX_INT_INT
#
# TODO: do we want also a MueLu_ENABLE_Complex option that turns ON automatically what we need?
IF(((NOT ${PACKAGE_NAME}_ENABLE_EXPLICIT_INSTANTIATION) AND Teuchos_ENABLE_COMPLEX)
    OR
    (HAVE_MUELU_INST_COMPLEX_INT_INT))
  SET(HAVE_${PACKAGE_NAME_UC}_COMPLEX ON)
ELSE()
  SET(HAVE_${PACKAGE_NAME_UC}_COMPLEX OFF)
ENDIF()

# mfh 18 Aug 2015: Revise whether complex is enabled, based on
# Tpetra's settings.  These are independent of whether ETI is enabled!
ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_Tpetra)
IF(${PACKAGE_NAME}_ENABLE_Tpetra)
  ASSERT_DEFINED(Tpetra_INST_COMPLEX_DOUBLE)
  IF(NOT Tpetra_INST_COMPLEX_DOUBLE)
    SET(HAVE_${PACKAGE_NAME_UC}_COMPLEX OFF)
  ENDIF()
ENDIF()

# The HAVE_MUELU_TPETRA_INST_INT_INT flag is enabled if Tpetra is enabled
# with TPETRA_INST_INT_INT. This flag is used to control whether we need
# special stub implementations for the MueLu::Tpetra stack with GO=int.
# taw 9 Oct 2015: This is independent from ETI on/off
IF (${PACKAGE_NAME}_ENABLE_Tpetra)
  ASSERT_DEFINED(Tpetra_INST_INT_INT)
  SET (${PACKAGE_NAME}_TPETRA_INST_INT_INT ${Tpetra_INST_INT_INT})
ENDIF()
GLOBAL_SET (HAVE_MUELU_TPETRA_INST_INT_INT ${${PACKAGE_NAME}_TPETRA_INST_INT_INT})

# ML's MMM
TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_ML_MMM
  HAVE_${PACKAGE_NAME_UC}_ML_MMM
  "Use ML's Matrix-Matrix-Multiply when available"
  OFF)
IF (${PACKAGE_NAME}_ENABLE_ML_MMM AND NOT ${PACKAGE_NAME}_ENABLE_ML)
  MESSAGE(FATAL_ERROR "Option MueLu_ENABLE_ML_MMM=ON requires MueLu_ENABLE_ML=ON.")
ENDIF ()


#
# C) Add the libraries, tests, and examples
#

# The build has to be in a very specific order because of the existence of Matlab interface:
#   1. Build the majority of the code in src/   [except src/Interface; src/CMakeLists.txt is responsible for ignoring that]
#   2. Build matlab factories                   [located in matlab/; matlab/bin is ignored in matlab/CMakeLists.txt]
#   3. Build the interpreter                    [requires all factories]
#   4. Build the adapters                       [required for Matlab]
#   5. Build the rest of matlab code
# This order required splitting of the src/ library into two: muelu and muelu-interface, as steps 1. and 3. are separated.
# A simple diagram explains this:
#                                               /  muelu
# matlab/bin - muelu-adapters - muelu-interface      |
#                                               \  matlab
ADD_SUBDIRECTORY(src)

if(TPL_ENABLE_MATLAB)
  if (NOT ${PROJECT_NAME}_ENABLE_EXPLICIT_INSTANTIATION)
    MESSAGE(FATAL_ERROR "Muemex interfaces require \"-DTrilinos_ENABLE_EXPLICIT_INSTANTIATION:BOOL=ON\".")
  ENDIF()
  IF(NOT ${PACKAGE_NAME}_ENABLE_Epetra OR NOT ${PACKAGE_NAME}_ENABLE_Tpetra)

=== packages/phalanx/CMakeLists.txt ===
INCLUDE(CombinedOption)

#
# A) Define the package
#

TRIBITS_PACKAGE(Phalanx)

#
# B) Set up package-specific options
#

TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ALLOW_MULTIPLE_EVALUATORS_FOR_SAME_FIELD
  PHX_ALLOW_MULTIPLE_EVALUATORS_FOR_SAME_FIELD
  "Enable to use backwards compatible mode where multiple evaluators can be registered that evalaute the same field. Phalanx will use the first evaluator it finds. This should default to off but for backwards compatibility with current codes, we default this to ON."
  ON )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_EXPLICIT_TEMPLATE_INSTANTIATION
  PHX_ETI
  "Build with explicit template instation enabled."
  OFF )

# If not explicitly defined by the user, pick a default node type that
# is enabled in kokkos.  This is complicated by ETI node type
# instantiation in Tpetra.  We need to use a node instantiated by
# Tpetra for panzer to build correctly.  Below we copy the logic from
# Tpetra for choosing the default node type to be in line with tpetra.
# This is somewhat fragile until we get new ETI system in place.
IF(NOT DEFINED ${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE)
  IF (Kokkos_ENABLE_Cuda)
    SET(${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE "CUDA")
  ELSE()
    IF (Kokkos_ENABLE_OpenMP)
      SET(${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE "OPENMP")
    ELSE()
      IF (Kokkos_ENABLE_Serial)
        SET(${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE "SERIAL")
      ELSE()
        IF (Kokkos_ENABLE_Pthread)
          SET(${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE "THREAD")
        ELSE()
	  MESSAGE(FATAL_ERROR "No Kokkos execution space is enabled.")
        ENDIF()
      ENDIF()
    ENDIF()
  ENDIF()
ENDIF()

IF(${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE STREQUAL "OPENMP")
  SET(PHX_KOKKOS_DEVICE_TYPE_OPENMP ON)
  MESSAGE(STATUS "Execution Space: OPENMP")
ELSEIF(${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE STREQUAL "CUDA")
  SET(PHX_KOKKOS_DEVICE_TYPE_CUDA ON)
  MESSAGE(STATUS "Execution Space: CUDA")
ELSEIF(${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE STREQUAL "THREAD")
  SET(PHX_KOKKOS_DEVICE_TYPE_THREAD ON)
  MESSAGE(STATUS "Execution Space: THREAD")
ELSEIF(${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE STREQUAL "SERIAL")
  SET(PHX_KOKKOS_DEVICE_TYPE_SERIAL ON)
  MESSAGE(STATUS "Execution Space: SERIAL")
ELSE()
  MESSAGE(FATAL_ERROR, " The specified device type ${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE = ${${PACKAGE_NAME}_KOKKOS_DEVICE_TYPE} is not valid!  Please set this to one of the valid device types: SERIAL,OPENMP,CUDA,THREAD.")
ENDIF()

# Index size type
IF(NOT DEFINED ${PACKAGE_NAME}_INDEX_SIZE_TYPE)
  SET(${PACKAGE_NAME}_INDEX_SIZE_TYPE "UINT")
ENDIF()

IF(${PACKAGE_NAME}_INDEX_SIZE_TYPE STREQUAL "KOKKOS")
  SET(PHX_INDEX_SIZE_TYPE_KOKKOS ON)
  MESSAGE(STATUS "Index Size Type: KOKKOS")
ELSEIF(${PACKAGE_NAME}_INDEX_SIZE_TYPE STREQUAL "INT")
  SET(PHX_INDEX_SIZE_TYPE_INT ON)
  MESSAGE(STATUS "Index Size Type: INT")
ELSEIF(${PACKAGE_NAME}_INDEX_SIZE_TYPE STREQUAL "UINT")
  SET(PHX_INDEX_SIZE_TYPE_UINT ON)
  MESSAGE(STATUS "Index Size Type: UINT")
ELSEIF(${PACKAGE_NAME}_INDEX_SIZE_TYPE STREQUAL "LONGINT")
  SET(PHX_INDEX_SIZE_TYPE_LONGINT ON)
  MESSAGE(STATUS "Index Size Type: LONGINT")
ELSEIF(${PACKAGE_NAME}_INDEX_SIZE_TYPE STREQUAL "ULONGINT")
  SET(PHX_INDEX_SIZE_TYPE_ULONGINT ON)
  MESSAGE(STATUS "Index Size Type: ULONGINT")
ELSE()
  MESSAGE(FATAL_ERROR, " The specified index size type ${PACKAGE_NAME}_INDEX_SIZE_TYPE = ${${PACKAGE_NAME}_INDEX_SIZE_TYPE} is not valid!  Please set this to one of the valid types: KOKKOS,INT,UINT,LONGINT,ULONGINT.")
ENDIF()

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_DEBUG
  PHX_DEBUG
  "Build with debug code enabled. Typically, this enables array bounds checking and runtime checking of rank accessors in multidimensional arrays."
  OFF )

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_TEUCHOS_TIME_MONITOR
  PHX_TEUCHOS_TIME_MONITOR
  "Build with Teuchos TimeMonitors wrapped around each evaluator."
  "${${PROJECT_NAME}_ENABLE_TEUCHOS_TIME_MONITOR}" )

IF(${PACKAGE_NAME}_ENABLE_Intrepid2)
  MESSAGE(STATUS "Build MDField support for Intrepid: ON")
ELSE()
  MESSAGE(STATUS "Build MDField support for Intrepid: OFF")
ENDIF()

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

#
# D) Do standard postprocessing
#

INSTALL(PROGRAMS scripts/phalanx_create_evaluator.py 
	DESTINATION bin) 

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/seacas/CMakeLists.txt ===
INCLUDE(TribitsPackageMacros)
INCLUDE(TribitsAddOptionAndDefine)

#
# A) Define the package
#

TRIBITS_PACKAGE_DECL( SEACAS ENABLE_SHADOWING_WARNINGS DISABLE_STRONG_WARNINGS )

TRIBITS_ADD_DEBUG_OPTION()
TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

#
# B) Set up package-specific options
#

#
# C) Add the libraries, tests, and examples
#- Add executable that will be installed in bin dir...
#
#  ADD_BIN_EXECUTABLE(<executable>)
#
function(install_executable target)
  INSTALL(TARGETS ${target} COMPONENT ${PACKAGE_NAME} RUNTIME DESTINATION ${${PROJECT_NAME}_INSTALL_RUNTIME_DIR})
endfunction()

TRIBITS_PROCESS_SUBPACKAGES()

TRIBITS_PACKAGE_DEF()

ADD_SUBDIRECTORY(scripts)

TRIBITS_EXCLUDE_FILES(
  doc
  )
  
#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/tpetra/CMakeLists.txt ===
############################################################
# Define the package
############################################################

# NOTE: If the TBB (Intel's Threading Building Blocks) TPL is enabled,
# it's probably not possible to build Tpetra with shadowing warnings.
#TRIBITS_PACKAGE( Tpetra ENABLE_SHADOWING_WARNINGS CLEANED )
TRIBITS_PACKAGE( Tpetra CLEANED )

TRIBITS_ADD_DEBUG_OPTION()

TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

TRIBITS_SET_ST_FOR_DEV_MODE(ST_FOR_DEV_PT_FOR_RELEASE)

# Kokkos and Tpetra require C++11 as of the 12.0 release.
#
# I left a special case for CUDA because I'm not sure whether TriBITS
# counts C++11 as enabled in that case; please feel free to revise if
# you know better.
ASSERT_DEFINED(${PROJECT_NAME}_ENABLE_CXX11)
ASSERT_DEFINED(TPL_ENABLE_CUDA)
IF (NOT ${PROJECT_NAME}_ENABLE_CXX11 AND NOT TPL_ENABLE_CUDA)
  MESSAGE(FATAL_ERROR "As of Trilinos 12.0, C++11 is REQUIRED when building Kokkos and its downstream packages, which include Tpetra.  You MUST enable C++11 when building these packages.  Trilinos should enable this by default, if your C++11 compiler supports C++11 (that is, if it's not too old).  If you set Trilinos_ENABLE_CXX11=OFF, then you are disabling C++11.  DON'T DO THAT if you want to build Kokkos or its downstream packages, including Tpetra.  If you aren't happy about that, then you need to disable Kokkos explicitly, by setting Trilinos_ENABLE_Kokkos=OFF.  This WILL disable Tpetra and its downstream packages.")
ENDIF ()

TRIBITS_ADD_OPTION_AND_DEFINE(
  Tpetra_ENABLE_Kokkos_Refactor
  TPETRA_ENABLE_KOKKOS_REFACTOR
  "Enable the \"Kokkos refactor\" version of Tpetra.  DO NOT SET THIS EXPLICITLY!  It is ON by default and that is the only supported value."
  ON
  )
IF (NOT Tpetra_ENABLE_Kokkos_Refactor)
  MESSAGE(FATAL_ERROR "The 'classic' version of Tpetra has been deprecated for a long time, and is not longer available.  If you don't want to see this message, please stop setting Tpetra_ENABLE_Kokkos_Refactor to OFF.  (It is ON by default; you should not set it explicitly.)")
ENDIF ()

######################################################################
# Explicit template instantiation (ETI) and test instantiation logic
######################################################################

# For
#   - Scalar types,
#   - (LocalOrdinal, GlobalOrdinal) type pairs, and
#   - Node types,
#
# Tpetra defines macros which say
#   1. Whether Tpetra instantiates (if ETI is enabled) and/or tests
#      its objects for that type (or type pair)
#   2. Whether the type (or type pair) is available
#
# If ETI is enabled, both are identical.  If not, the settings of the
# latter depend on both Kokkos settings and Trilinos' settings.
#
# The availability macros have the following pattern: HAVE_TPETRA_[TYPE]
# The instantiation macros have the pattern:          HAVE_TPETRA_INST_[TYPE]
# The CMake options have the pattern:                 Tpetra_INST_[TYPE]
#
# The availability and instantiation macros are THE SAME.
#
# The ordinal types are: INT_INT, INT_UNSIGNED, INT_LONG, INT_LONG_LONG, INT_UNSIGNED_LONG
# The node types are:    SERIAL, OPENMP, PTHREAD, CUDA
# The scalar types are:  DOUBLE, FLOAT, COMPLEX_DOUBLE, COMPLEX_FLOAT
#
# A downstream package or application should use the availability
# macros to check whether something can be used/instantiated.
#
# Note on (1) above: Tpetra also adds enabled GlobalOrdinal types
# internally to the Scalar types for instantiation of MultiVector.
#
# Note on (2) above: some of the types can only be enabled if certain
# requirements are fulfilled.
#
# Tpetra also keeps a list of the Kokkos Device types (specializations
# of Kokkos::Device) over which it does instantiations and/or tests.
# This is the Tpetra_ETI_DEVICES CMake variable.  Eventually, we will
# deprecate and remove the above Node instantiation list, and just use
# the list of enabled Devices.  We use devices rather than execution
# spaces, because a Kokkos::Device is an (execution space, memory
# space) pair.  This means that it is more general.  For example,
# Device<Cuda, CudaSpace> != Device<Cuda, CudaUVMSpace>, yet some
# users may want both represented.  The particular use case I have in
# mind here is Device<OpenMP, $MEM_SPACE> where $MEM_SPACE could be
# either HostSpace or the HBM (high-bandwidth memory) memory space.
#

SET(${PACKAGE_NAME}_ETI_SCALARS "")
# Exclude all ordinal types (GlobalOrdinal and int)
SET(${PACKAGE_NAME}_ETI_SCALARS_NO_ORDS "")
SET(${PACKAGE_NAME}_ETI_LORDS "")
SET(${PACKAGE_NAME}_ETI_GORDS "")
SET(${PACKAGE_NAME}_ETI_DEVICES "")
SET(${PACKAGE_NAME}_ETI_NODES "")

# ============================================================
# Kokkos execution space types
# ============================================================

# Decide what Kokkos execution spaces to use by default.  If ETI is
# ON, "using an execution space ExecutionSpace" means that Tpetra
# objects with Node =
# Kokkos::Compat::KokkosDeviceWrapperNode<ExecutionSpace> will
#
#   1. get instantiated explicitly for that Node type, and
#   2. get tested for that Node type, if their test is also
#      templated on Node type.
#
# If ETI is OFF, #1 no longer holds, but #2 still holds.
#
# Tpetra uses exactly one Kokkos execution space by default, whether
# ETI is ON or OFF.  This keeps build times for tests down in the
# non-ETI case, and library sizes small in the ETI case.

GLOBAL_SET(HAVE_TPETRA_INST_SERIAL_DEFAULT OFF)
GLOBAL_SET(HAVE_TPETRA_INST_PTHREAD_DEFAULT OFF)
GLOBAL_SET(HAVE_TPETRA_INST_OPENMP_DEFAULT OFF)  
GLOBAL_SET(HAVE_TPETRA_INST_CUDA_DEFAULT OFF)  

IF (Kokkos_ENABLE_Cuda) 
  # If you bothered to build with CUDA enabled, then we assume you
  # only want CUDA.
  GLOBAL_SET(HAVE_TPETRA_INST_CUDA_DEFAULT ON)  
ELSE()
  IF (Kokkos_ENABLE_OpenMP) 
    # It takes effort (setting a nondefault compiler flag) to turn
    # on OpenMP, so we assume that if OpenMP is ON, then you must
    # want it as the Node type.
    GLOBAL_SET(HAVE_TPETRA_INST_OPENMP_DEFAULT ON)  
  ELSE()
    IF (Kokkos_ENABLE_Serial)
      GLOBAL_SET(HAVE_TPETRA_INST_SERIAL_DEFAULT ON)
    ELSE()
      IF (Kokkos_ENABLE_Pthread)
        GLOBAL_SET(HAVE_TPETRA_INST_PTHREAD_DEFAULT ON)
      ELSE()
        MESSAGE(FATAL_ERROR "Tpetra: No Kokkos execution space is enabled.  This message should only come up if you explicitly disabled all the Kokkos execution spaces.  If you don't want Tpetra to use threads, try setting Kokkos_ENABLE_Serial=ON.")
      ENDIF()  # Kokkos_ENABLE_Pthread
    ENDIF() # Kokkos_ENABLE_Serial
  ENDIF() # Kokkos_ENABLE_OpenMP
ENDIF() # Kokkos_ENABLE_Cuda

# Don't turn on both Serial and Threads by default.  Prefer Serial,
# because Threads is a last resort.  Of course, users may still
# enable Threads explicitly, by setting TPETRA_INST_PTHREAD=ON.
IF (HAVE_TPETRA_INST_SERIAL_DEFAULT AND HAVE_TPETRA_INST_PTHREAD_DEFAULT)
  GLOBAL_SET(HAVE_TPETRA_INST_PTHREAD_DEFAULT OFF)
ENDIF ()

# The Kokkos refactor version of Tpetra is ON, so the "classic" Node
# type must be OFF.  (We will enforce this below.)
GLOBAL_SET(HAVE_TPETRA_INST_SERIALCLASSIC_DEFAULT OFF)

# Set up all the public "Tpetra_INST_*" CMake options for enabling
# Node types.  Each enables both instantations and tests in the ETI ON
# case, and only tests in the ETI OFF case.  Nevertheless, the options
# exist whether ETI is ON or OFF.
#
# While setting up the options, check that the default Node type is
# actually enabled.  Print out a helpful STATUS message if a Kokkos
# execution space is ON, but ETI for its corresponding Node type is
# OFF.  This may help users diagnose link errors.

# Kokkos::Serial (Kokkos::Compat::KokkosSerialWrapperNode)
TRIBITS_ADD_OPTION_AND_DEFINE(
  Tpetra_INST_SERIAL
  HAVE_TPETRA_INST_SERIAL
  "Instantiate and/or test Tpetra classes over Node = Kokkos::Compat::KokkosSerialWrapperNode.  If ETI is OFF, enable tests for that Node type.  This option is ${HAVE_TPETRA_INST_SERIAL_DEFAULT} by default."
  ${HAVE_TPETRA_INST_SERIAL_DEFAULT}
  )
GLOBAL_SET(HAVE_TPETRA_SERIAL ${Tpetra_INST_SERIAL})
IF (Tpetra_INST_SERIAL)
  IF (NOT Kokkos_ENABLE_Serial)
    MESSAGE(FATAL_ERROR "Tpetra: The Kokkos::Serial execution space is disabled, but you enabled the corresponding Tpetra Node type by setting Tpetra_INST_SERIAL=ON.  If you want to enable instantiation and use of Kokkos::Serial in Tpetra, you must enable the Kokkos::Serial execution space by setting Kokkos_ENABLE_Serial=ON.")
  ENDIF ()
ELSE () # NOT Tpetra_INST_SERIAL
  IF (HAVE_TPETRA_DEFAULTNODE_SERIALWRAPPERNODE)
    MESSAGE(FATAL_ERROR "Tpetra: Node = Kokkos::Compat::KokkosSerialWrapperNode is disabled (since Tpetra_INST_SERIAL=OFF), but you set it as the default Node type.  Try setting the CMake options Kokkos_ENABLE_Serial:BOOL=ON and Tpetra_INST_SERIAL:BOOL=ON.")
  ENDIF ()
  IF (Kokkos_ENABLE_Serial)
    MESSAGE(STATUS "NOTE: Kokkos::Serial is ON (the CMake option Kokkos_ENABLE_Serial is ON), but the corresponding Tpetra Node type is disabled.  If you want to enable instantiation and use of Kokkos::Serial in Tpetra, please also set the CMake option Tpetra_INST_SERIAL:BOOL=ON.  If you use the Kokkos::Serial Node type in Tpetra without doing this, you will get link errors!")
  ENDIF ()
ENDIF () # Tpetra_INST_SERIAL

# Kokkos::OpenMP (Kokkos::Compat::KokkosOpenMPWrapperNode)
TRIBITS_ADD_OPTION_AND_DEFINE(
  Tpetra_INST_OPENMP
  HAVE_TPETRA_INST_OPENMP
  "Instantiate and/or test Tpetra classes over Node = Kokkos::Compat::KokkosOpenMPWrapperNode.  If ETI is OFF, enable tests for that Node type.  This option is ${HAVE_TPETRA_INST_OPENMP_DEFAULT} by default."
  ${HAVE_TPETRA_INST_OPENMP_DEFAULT}
  )
GLOBAL_SET(HAVE_TPETRA_OPENMP ${Tpetra_INST_OPENMP})
IF (Tpetra_INST_OPENMP)
  IF (NOT Kokkos_ENABLE_OpenMP)
    MESSAGE(FATAL_ERROR "Tpetra: The Kokkos::OpenMP execution space is disabled, but you enabled the corresponding Tpetra Node type by setting Tpetra_INST_OPENMP=ON.  If you want to enable instantiation and use of Kokkos::OpenMP in Tpetra, you must enable the Kokkos::OpenMP execution space by setting Kokkos_ENABLE_OpenMP=ON.")
  ENDIF ()
ELSE () # NOT Tpetra_INST_OPENMP
  IF (HAVE_TPETRA_DEFAULTNODE_OPENMPWRAPPERNODE)
    MESSAGE(FATAL_ERROR "Tpetra: Node = Kokkos::Compat::KokkosOpenMPWrapperNode is disabled (since Tpetra_INST_SERIAL=OFF), but you set it as the default Node type.  Try setting the CMake option Tpetra_INST_SERIAL:BOOL=ON.  If that does not work, also add Trilinos_ENABLE_OpenMP:BOOL=ON and possibly also Kokkos_ENABLE_OpenMP:BOOL=ON.")
  ENDIF()
  IF (Kokkos_ENABLE_OpenMP)
    MESSAGE(STATUS "NOTE: Kokkos::OpenMP is ON (the CMake option Kokkos_ENABLE_OpenMP is ON), but the corresponding Tpetra Node type is disabled.  If you want to enable instantiation and use of Kokkos::OpenMP in Tpetra, please also set the CMake option Tpetra_INST_OPENMP:BOOL=ON.  If you use the Kokkos::OpenMP Node type in Tpetra without doing this, you will get link errors!")
  ENDIF ()
ENDIF ()

# Kokkos::Threads (Kokkos::Compat::KokkosThreadsWrapperNode)
TRIBITS_ADD_OPTION_AND_DEFINE(
  Tpetra_INST_PTHREAD
  HAVE_TPETRA_INST_PTHREAD
  "Instantiate and/or test Tpetra classes over Node = Kokkos::Compat::KokkosThreadsWrapperNode.  If ETI is OFF, enable tests for that Node type.  This option is ${HAVE_TPETRA_INST_PTHREAD_DEFAULT} by default."
  ${HAVE_TPETRA_INST_PTHREAD_DEFAULT}
  )
GLOBAL_SET(HAVE_TPETRA_PTHREAD ${Tpetra_INST_PTHREAD})
IF (Tpetra_INST_PTHREAD)
  IF (NOT Kokkos_ENABLE_Pthread)
    MESSAGE(FATAL_ERROR "Tpetra: The Kokkos::Threads execution space is disabled, but you enabled the corresponding Tpetra Node type by setting Tpetra_INST_PTHREAD=ON [sic; it is really PTHREAD, not PTHREADS].  If you want to enable instantiation and use of Kokkos::Threads in Tpetra, you must enable the Kokkos::Threads execution space by setting Kokkos_ENABLE_Pthread=ON [again sic].")
  ENDIF ()
  IF (Tpetra_INST_OPENMP)

=== packages/xpetra/CMakeLists.txt ===
INCLUDE(CombinedOption)
INCLUDE(DualScopeSet)

#
# A) Define the package
#

TRIBITS_PACKAGE(Xpetra ENABLE_SHADOWING_WARNINGS)

# Add directory xpetra/cmake/ to the cmake module search path
DUAL_SCOPE_SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PACKAGE_SOURCE_DIR}/cmake)

#
# B) Set up package-specific options
#

TRIBITS_ADD_EXPLICIT_INSTANTIATION_OPTION()
TRIBITS_ADD_DEBUG_OPTION()
TRIBITS_ADD_SHOW_DEPRECATED_WARNINGS_OPTION()

# Enable experimental code
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_Experimental
  HAVE_${PACKAGE_NAME_UC}_EXPERIMENTAL
  "Enable experimental code."
  NO)

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_Tpetra)
GLOBAL_SET(HAVE_XPETRA_TPETRA ${${PACKAGE_NAME}_ENABLE_Tpetra})

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_Epetra)
GLOBAL_SET(HAVE_XPETRA_EPETRA ${${PACKAGE_NAME}_ENABLE_Epetra})

GLOBAL_SET(HAVE_XPETRA_EPETRAEXT ${${PACKAGE_NAME}_ENABLE_EpetraExt})

ASSERT_DEFINED(${PACKAGE_NAME}_ENABLE_Thyra)
GLOBAL_SET(HAVE_XPETRA_THYRA ${${PACKAGE_NAME}_ENABLE_Thyra})

# If Epetra is enabled, does it provide 64-bit global indices?
IF(${PACKAGE_NAME}_ENABLE_Epetra)

  # Set default value of whether Xpetra should allow for 32 bit Epetra data structures or not.
  IF(Trilinos_NO_32BIT_GLOBAL_INDICES)
    SET(${PACKAGE_NAME}_Epetra_NO_32BIT_GLOBAL_INDICES_DEFAULT ON)
  ELSE()
    SET(${PACKAGE_NAME}_Epetra_NO_32BIT_GLOBAL_INDICES_DEFAULT OFF)
  ENDIF()

  # Set default value of whether Xpetra should allow for 64 bit Epetra data structures or not.
  IF(Trilinos_NO_64BIT_GLOBAL_INDICES)
    SET(${PACKAGE_NAME}_Epetra_NO_64BIT_GLOBAL_INDICES_DEFAULT ON)
  ELSE()
    IF(Teuchos_ENABLE_LONG_LONG_INT AND Tpetra_INST_INT_LONG_LONG)
      SET(${PACKAGE_NAME}_Epetra_NO_64BIT_GLOBAL_INDICES_DEFAULT OFF)
    ELSE()
      SET(${PACKAGE_NAME}_Epetra_NO_64BIT_GLOBAL_INDICES_DEFAULT ON)
    ENDIF()
  ENDIF()

ELSE()

  SET(${PACKAGE_NAME}_Epetra_NO_32BIT_GLOBAL_INDICES_DEFAULT ON)
  SET(${PACKAGE_NAME}_Epetra_NO_64BIT_GLOBAL_INDICES_DEFAULT ON)

ENDIF()

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_Epetra_NO_32BIT_GLOBAL_INDICES
  ${PACKAGE_NAME_UC}_EPETRA_NO_32BIT_GLOBAL_INDICES
  "If option is enabled, 32-bit Epetra global indices are disabled in Xpetra.  One must use GlobalOrdinal = long long only."
  ${${PACKAGE_NAME}_Epetra_NO_32BIT_GLOBAL_INDICES_DEFAULT} )

IF(${PACKAGE_NAME}_Epetra_NO_32BIT_GLOBAL_INDICES_DEFAULT AND (NOT ${PACKAGE_NAME}_Epetra_NO_32BIT_GLOBAL_INDICES))
  MESSAGE(FATAL_ERROR "There are no 32 bit Epetra classes available but user requested Xpetra use them by setting ${PACKAGE_NAME}_Epetra_NO_32BIT_GLOBAL_INDICES OFF.")
ENDIF()

TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_Epetra_NO_64BIT_GLOBAL_INDICES
  ${PACKAGE_NAME_UC}_EPETRA_NO_64BIT_GLOBAL_INDICES
  "If option is enabled, 64-bit Epetra global indices are disabled in Xpetra.  One must use GlobalOrdinal = int only."
  ${${PACKAGE_NAME}_Epetra_NO_64BIT_GLOBAL_INDICES_DEFAULT} )

IF(${PACKAGE_NAME}_Epetra_NO_64BIT_GLOBAL_INDICES_DEFAULT AND (NOT ${PACKAGE_NAME}_Epetra_NO_64BIT_GLOBAL_INDICES))
  MESSAGE(FATAL_ERROR "There are no 64 bit Epetra classes available possibly because they are disabled or Teuchos_ENABLE_LONG_LONG_INT is OFF or long long support is not present in Tpetra but user requested Xpetra use them by setting ${PACKAGE_NAME}_Epetra_NO_64BIT_GLOBAL_INDICES OFF.")
ENDIF()

#
# Decide whether it makes sense to enable LocalOrdinal = int and
# GlobalOrdinal = long long.  This requires support for long long in
# Teuchos, and at least one of Epetra or Tpetra must also support
# LocalOrdinal = int and GlobalOrdinal = long long.
#
ASSERT_DEFINED (Teuchos_ENABLE_LONG_LONG_INT)
IF (NOT Teuchos_ENABLE_LONG_LONG_INT)
  # If Teuchos doesn't have support for long long, we won't get anywhere.
  SET (${PACKAGE_NAME}_INT_LONG_LONG OFF)
ELSE ()
  # Teuchos supports long long.  How about Epetra or Tpetra?
  IF (${PACKAGE_NAME}_ENABLE_Tpetra)
    # Does Tpetra provide LocalOrdinal = int and GlobalOrdinal = long long?
    ASSERT_DEFINED(Tpetra_INST_INT_LONG_LONG)
    SET (${PACKAGE_NAME}_INT_LONG_LONG ${Tpetra_INST_INT_LONG_LONG})
  ELSE () # Tpetra NOT enabled
    IF (${PACKAGE_NAME}_ENABLE_Epetra)
      # Does Epetra provide LocalOrdinal = int and GlobalOrdinal = long long?
      IF (${PACKAGE_NAME}_Epetra_NO_64BIT_GLOBAL_INDICES)
        SET (${PACKAGE_NAME}_INT_LONG_LONG OFF)
      ELSE ()
        SET (${PACKAGE_NAME}_INT_LONG_LONG ON)
      ENDIF ()
    ELSE () # Neither Epetra nor Tpetra are enabled
      SET (${PACKAGE_NAME}_INT_LONG_LONG OFF)
    ENDIF ()
  ENDIF ()
ENDIF ()

##################################

#
# Decide whether it makes sense to enable LocalOrdinal = int and
# GlobalOrdinal = int.
#
IF (${PACKAGE_NAME}_ENABLE_Epetra)
  # if Epetra is enabled we need basic GO=int support!
  SET (${PACKAGE_NAME}_INT_INT ON)
ELSE () # check whether Tpetra is enabled and needs GO=int support
  IF (${PACKAGE_NAME}_ENABLE_Tpetra)
    ASSERT_DEFINED(Tpetra_INST_INT_INT)
    SET (${PACKAGE_NAME}_INT_INT ${Tpetra_INST_INT_INT})
  ELSE () # Neither Epetra nor Tpetra are enabled or need GO=int support
    SET (${PACKAGE_NAME}_INT_INT OFF)
  ENDIF ()
ENDIF ()

# If Tpetra is enabled, determine which Nodes are used
IF (${PACKAGE_NAME}_ENABLE_Tpetra)
  GLOBAL_SET (HAVE_XPETRA_SERIAL  ${Tpetra_INST_SERIAL})
  GLOBAL_SET (HAVE_XPETRA_PTHREAD ${Tpetra_INST_PTHREAD})
  GLOBAL_SET (HAVE_XPETRA_OPENMP  ${Tpetra_INST_OPENMP})
  GLOBAL_SET (HAVE_XPETRA_CUDA    ${Tpetra_INST_CUDA})
ENDIF()
IF (${PACKAGE_NAME}_ENABLE_Epetra)
  # If Epetra is active, enable Serial node
  GLOBAL_SET (HAVE_XPETRA_SERIAL  ON)
ENDIF ()

  MESSAGE(STATUS "HAVE_XPETRA_SERIAL       : ${HAVE_XPETRA_SERIAL}")
  MESSAGE(STATUS "HAVE_XPETRA_PTHREAD      : ${HAVE_XPETRA_PTHREAD}")
  MESSAGE(STATUS "HAVE_XPETRA_OPENMP       : ${HAVE_XPETRA_OPENMP}")
  MESSAGE(STATUS "HAVE_XPETRA_CUDA         : ${HAVE_XPETRA_CUDA}")


##################################

TRIBITS_ADD_OPTION_AND_DEFINE(XPETRA_ENABLE_PROFILING
  HAVE_XPETRA_PROFILING
  "Enable detailed timing of Xpetra."
  OFF)

# Define option to enable code that is refactored to use Kokkos
TRIBITS_ADD_OPTION_AND_DEFINE(
  ${PACKAGE_NAME}_ENABLE_Kokkos_Refactor
  HAVE_${PACKAGE_NAME_UC}_KOKKOS_REFACTOR
  "Enable Xpetra code refactored to use Kokkos."
  NO)

#
#
#

ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(sup)

IF(${PACKAGE_NAME}_ENABLE_BROKEN_TESTS)
    TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)
ENDIF()
TRIBITS_ADD_TEST_DIRECTORIES(test)

#
# Exclude files for source package.
#

TRIBITS_EXCLUDE_AUTOTOOLS_FILES()

TRIBITS_EXCLUDE_FILES(
  test/BlockedCrsOperator
  )

#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/zoltan2/CMakeLists.txt ===

# Path to test and example data directory
#KDD NOT WORKING IN NIGHTLY TEST SYSTEM
#KDD BETTER SOLUTION:  COPY THE NEEDED INPUT FILES AND USE FROM RUN DIRECTORY
#KDD SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DZ2_DATA_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/test/data/\"")

# Path to Zoltan1 test directory
#KDD WILL NEED TO FIX THIS CASE AS WELL, BUT IT IS NOT USED IN NIGHTLY TESTING
#KDD SINCE NIGHTLY TESTS DO NOT ENABLE Experimental TESTS.
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DZ1_TEST_DIR=\"${CMAKE_CURRENT_SOURCE_DIR}/../../packages/zoltan/test/\"")

#
# A) Define the package
#

TRIBITS_PACKAGE(Zoltan2 ENABLE_SHADOWING_WARNINGS)

#
# A2) Enable required explicit instantiation types
#     Zoltan2 requires scalar_t = int; add it here.
#     See Bug 6298.
#

FOREACH(ZNODE_TYPE  ${TpetraCore_ETI_NODES})
  FOREACH(ZLO_TYPE  ${TpetraCore_ETI_LORDS})
    FOREACH(ZGO_TYPE  ${TpetraCore_ETI_GORDS})
      TRIBITS_ADD_ETI_INSTANTIATIONS(TpetraCore
        "S={int} LO={${ZLO_TYPE}} GO={${ZGO_TYPE}} N={${ZNODE_TYPE}}")
    ENDFOREACH()
  ENDFOREACH()
ENDFOREACH()

#
# B) Set up package-specific options
#

IF (${PROJECT_NAME}_ENABLE_Epetra)
 GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_EPETRA ON)
ENDIF ()

IF (${PROJECT_NAME}_ENABLE_Galeri)
 GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_GALERI ON)
ENDIF ()

IF (${PROJECT_NAME}_ENABLE_Pamgen)
 GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_PAMGEN ON)
ENDIF ()

TRIBITS_ADD_OPTION_AND_DEFINE(
   ${PACKAGE_NAME}_ENABLE_UseZoltanComm
   ${PACKAGE_NAME_UC}_USEZOLTANCOMM
   "For migration in MJ, use Zoltan's comm package instead of Tpetra."
   OFF)


TRIBITS_ADD_OPTION_AND_DEFINE(
   ${PACKAGE_NAME}_ENABLE_Experimental
   INCLUDE_${PACKAGE_NAME_UC}_EXPERIMENTAL
   "Enable experimental code."
   OFF)

TRIBITS_ADD_OPTION_AND_DEFINE(
   ${PACKAGE_NAME}_ENABLE_Experimental_Wolf
   INCLUDE_${PACKAGE_NAME_UC}_EXPERIMENTAL_WOLF
   "Enable wolf experimental code."
   OFF)

IF (${PROJECT_NAME}_ENABLE_SCOREC)
 GLOBAL_SET(HAVE_${PACKAGE_NAME_UC}_PARMA ON)
ENDIF ()

SET(HAVE_${PACKAGE_NAME_UC}_MPI ${TPL_ENABLE_MPI})

#TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_METIS
#  HAVE_${PACKAGE_NAME_UC}_METIS
#  "Metis is present"
#  OFF )

#TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_PaToH
#  HAVE_${PACKAGE_NAME_UC}_PATOH
#  "PaToH is present"
#  OFF )

#TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_ParMETIS
#  HAVE_${PACKAGE_NAME_UC}_PARMETIS
#  "ParMetis is present"
#  OFF )

#TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_Scotch
#  HAVE_${PACKAGE_NAME_UC}_SCOTCH
#  "Scotch is present"
#  OFF )

#TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_OVIS
#  HAVE_${PACKAGE_NAME_UC}_OVIS
#  "Ovis is present"
#  OFF )

#TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_AMD
#  HAVE_${PACKAGE_NAME_UC}_AMD
#  "AMD is present"
#  OFF )

#TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_ANASAZI
#  HAVE_${PACKAGE_NAME_UC}_ANASAZI
#  "Anasazi is present"
#  OFF )

#
# See the comment in Zoltan2_AlgScotch.hpp to learn how to
# modify the scotch library to return the maximum memory used.
#
TRIBITS_ADD_OPTION_AND_DEFINE(${PACKAGE_NAME}_ENABLE_SCOTCH_MEMORY_REPORT
  SHOW_${PACKAGE_NAME_UC}_SCOTCH_MEMORY
  "turn on runtime display maximum memory used by scotch"
  OFF )


#INCLUDE(CheckTypeSize)
#CHECK_TYPE_SIZE("long long" HAVE_${PACKAGE_NAME_UC}_LONG_LONG)

#
# C) Add the libraries, tests, and examples
#

ADD_SUBDIRECTORY(src)

TRIBITS_ADD_TEST_DIRECTORIES(test)

TRIBITS_ADD_EXAMPLE_DIRECTORIES(example)

#
# Exclude files for source package.
#
#TRIBITS_EXCLUDE_FILES()


#
# D) Do standard postprocessing
#

TRIBITS_PACKAGE_POSTPROCESS()

=== packages/amesos/src/CMakeLists.txt ===


#
# A) Package-specific configuration options
#

#SET(HAVE_BOOL ON)
#SET(HAVE_STL ON)

TRIBITS_CONFIGURE_FILE(${PACKAGE_NAME}_config.h)

#
# B) Define the header and source files (and directories)
#

#
# src
#

SET(HEADERS "")
SET(SOURCES "")

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

SET(HEADERS ${HEADERS}
  ${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE_NAME}_config.h
  )

#
# support files
#

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

SET(SOURCES ${SOURCES}
  Amesos_Status.cpp
  Amesos_Control.cpp
  Amesos_Support.cpp
  )

#
# DSCPACK files
#

IF (${PACKAGE_NAME}_ENABLE_DSCPACK)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

  SET(HEADERS ${HEADERS}
    Amesos_Dscpack.h
    )

  SET(SOURCES ${SOURCES}
    Amesos_Dscpack.cpp
    )
ENDIF()

#
# UMFPACK files
#

IF (${PACKAGE_NAME}_ENABLE_UMFPACK)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

  SET(HEADERS ${HEADERS}
    Amesos_Umfpack.h
    )

  SET(SOURCES ${SOURCES}
    Amesos_Umfpack.cpp
    )
ENDIF()

#
# MUMPS files
#

IF (${PACKAGE_NAME}_ENABLE_MUMPS)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

  SET(HEADERS ${HEADERS}
    Amesos_Mumps.h
    )

  SET(SOURCES ${SOURCES}
    Amesos_Mumps.cpp
    )
ENDIF()

#
# PARDISO files
#

IF (${PACKAGE_NAME}_ENABLE_PARDISO OR ${PACKAGE_NAME}_ENABLE_PARDISO_MKL)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

  SET(HEADERS ${HEADERS}
    Amesos_Pardiso.h
    )

  SET(SOURCES ${SOURCES}
    Amesos_Pardiso.cpp
    )
ENDIF()

#
# CSparse files
#

IF (${PACKAGE_NAME}_ENABLE_CSparse OR ${PACKAGE_NAME}_ENABLE_CSparse)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

  SET(HEADERS ${HEADERS}
    Amesos_CSparse.h
    )

  SET(SOURCES ${SOURCES}
    Amesos_CSparse.cpp
    )
ENDIF()

#
# TAUCS files
#

IF (${PACKAGE_NAME}_ENABLE_TAUCS)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

  SET(HEADERS ${HEADERS}
    Amesos_Taucs.h
    )

  SET(SOURCES ${SOURCES}
    Amesos_Taucs.cpp
    )
ENDIF()

#
# PARAKLETE KLU files
#

SET(PARAKLETE_KLU_COMMON_H
  SuiteSparse/AMD/Include/amesos_amd.h
  SuiteSparse/AMD/Include/amesos_amd_internal.h
  SuiteSparse/COLAMD/Include/amesos_colamd.h
  SuiteSparse/CHOLMOD/Include/amesos_cholmod_check.h
  SuiteSparse/CHOLMOD/Include/amesos_cholmod_core.h
  SuiteSparse/CHOLMOD/Include/amesos_cholmod.h
  SuiteSparse/CHOLMOD/Include/amesos_cholmod_internal.h
  SuiteSparse/CHOLMOD/Include/amesos_cholmod_io64.h
  SuiteSparse/CHOLMOD/Include/amesos_cholmod_partition.h
  SuiteSparse/UFconfig/amesos_UFconfig.h
  )

SET(PARAKLETE_KLU_COMMON
  SuiteSparse/AMD/Source/amesos_amd_1.c
  SuiteSparse/AMD/Source/amesos_amd_2.c
  SuiteSparse/AMD/Source/amesos_amd_aat.c
  SuiteSparse/AMD/Source/amesos_amd_control.c
  SuiteSparse/AMD/Source/amesos_amd_defaults.c
  SuiteSparse/AMD/Source/amesos_amd_dump.c
  SuiteSparse/AMD/Source/amesos_amd_global.c
  SuiteSparse/AMD/Source/amesos_amd_info.c
  SuiteSparse/AMD/Source/amesos_amd_order.c
  SuiteSparse/AMD/Source/amesos_amd_postorder.c
  SuiteSparse/AMD/Source/amesos_amd_post_tree.c
  SuiteSparse/AMD/Source/amesos_amd_preprocess.c
  SuiteSparse/AMD/Source/amesos_amd_valid.c
  SuiteSparse/AMD/Source/amesos_amd_l1.c
  SuiteSparse/AMD/Source/amesos_amd_l2.c
  SuiteSparse/AMD/Source/amesos_amd_l_aat.c
  SuiteSparse/AMD/Source/amesos_amd_l_order.c
  SuiteSparse/AMD/Source/amesos_amd_l_postorder.c
  SuiteSparse/AMD/Source/amesos_amd_l_post_tree.c
  SuiteSparse/AMD/Source/amesos_amd_l_preprocess.c
  SuiteSparse/AMD/Source/amesos_amd_l_valid.c
  SuiteSparse/COLAMD/Source/amesos_colamd.c
  SuiteSparse/COLAMD/Source/amesos_colamd_l.c
  SuiteSparse/COLAMD/Source/amesos_colamd_global.c
  SuiteSparse/CHOLMOD/Core/amesos_cholmod_common.c
  SuiteSparse/CHOLMOD/Core/amesos_cholmod_complex.c
  SuiteSparse/CHOLMOD/Core/amesos_cholmod_error.c
  SuiteSparse/CHOLMOD/Core/amesos_cholmod_memory.c
  SuiteSparse/CHOLMOD/Core/amesos_cholmod_sparse.c
  SuiteSparse/CHOLMOD/Core/amesos_cholmod_transpose.c
  SuiteSparse/CAMD/Source/amesos_camd_2.c
  SuiteSparse/CAMD/Source/amesos_camd_postorder.c
  )


  IF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
      IF(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.2)
        SET_SOURCE_FILES_PROPERTIES(${PARAKLETE_KLU_COMMON},
                PROPERTIES
                COMPILE_FLAGS "-Wno-all -Wno-pedantic")
      ENDIF()
  ELSEIF (WIN32 AND NOT CYGWIN)
       # No flags
  ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "PGI")
      #No flags
  ELSE()
       SET_SOURCE_FILES_PROPERTIES(${PARAKLETE_KLU_COMMON},
                PROPERTIES
                COMPILE_FLAGS "-Wno-all")
  ENDIF()

         

#
# KLU files
#

IF (${PACKAGE_NAME}_ENABLE_KLU)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/AMD/Include)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/COLAMD/Include)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/CHOLMOD/Include)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/UFconfig)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/KLU/Include)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/BTF/Include)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/CAMD/Include)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/CCOLAMD/Include)

  SET(HEADERS ${HEADERS}
    ${PARAKLETE_KLU_COMMON_H}
    SuiteSparse/KLU/Include/amesos_klu_decl.h
    SuiteSparse/KLU/Include/amesos_klu_internal.h
    SuiteSparse/KLU/Include/amesos_klu_version.h
    SuiteSparse/BTF/Include/amesos_btf_decl.h
    SuiteSparse/BTF/Include/amesos_btf_internal.h
    SuiteSparse/CCOLAMD/Include/amesos_ccolamd.h
    Amesos_Klu.h
    )

   SET(KLU_FILES
   SuiteSparse/KLU/Source/amesos_klu_analyze.c
    SuiteSparse/KLU/Source/amesos_klu_analyze_given.c
    SuiteSparse/KLU/Source/amesos_klu_impl.c
    SuiteSparse/KLU/Source/amesos_klu_defaults.c
    SuiteSparse/KLU/Source/amesos_klu_diagnostics.c
    SuiteSparse/KLU/Source/amesos_klu_dump.c
    SuiteSparse/KLU/Source/amesos_klu_extract.c
    SuiteSparse/KLU/Source/amesos_klu_factor.c
    SuiteSparse/KLU/Source/amesos_klu_free_numeric.c
    SuiteSparse/KLU/Source/amesos_klu_free_symbolic.c
    SuiteSparse/KLU/Source/amesos_klu_kernel.c
    SuiteSparse/KLU/Source/amesos_klu_memory.c
    SuiteSparse/KLU/Source/amesos_klu_refactor.c
    SuiteSparse/KLU/Source/amesos_klu_scale.c
    SuiteSparse/KLU/Source/amesos_klu_solve.c
    SuiteSparse/KLU/Source/amesos_klu_sort.c
    SuiteSparse/KLU/Source/amesos_klu_tsolve.c
    SuiteSparse/BTF/Source/amesos_btf_order.c
    SuiteSparse/BTF/Source/amesos_btf_maxtrans.c
    SuiteSparse/BTF/Source/amesos_btf_strongcomp.c
    SuiteSparse/BTF/Source/amesos_btf_l_order.c
    SuiteSparse/BTF/Source/amesos_btf_l_maxtrans.c
    SuiteSparse/BTF/Source/amesos_btf_l_strongcomp.c
    SuiteSparse/CCOLAMD/Source/amesos_ccolamd.c
    SuiteSparse/CCOLAMD/Source/amesos_ccolamd_l.c
    SuiteSparse/CCOLAMD/Source/amesos_ccolamd_global.c
    )
    

    IF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
        IF(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.2)
        SET_SOURCE_FILES_PROPERTIES(${KLU_FILES},
                PROPERTIES
                COMPILE_FLAGS "-Wno-all -Wno-pedantic")
        ENDIF()
    ELSEIF (WIN32 AND NOT CYGWIN)
       # No flags
    ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "PGI")
      #No flags
    ELSE()
         SET_SOURCE_FILES_PROPERTIES(${KLU_FILES},
                PROPERTIES
                COMPILE_FLAGS "-Wno-all")
    ENDIF()



    SET(SOURCES ${SOURCES}
    ${PARAKLETE_KLU_COMMON}
    Amesos_Klu.cpp
    ${KLU_FILES}
    )

ENDIF()

#
# PARAKLETE files
#

IF (${PACKAGE_NAME}_ENABLE_PARAKLETE)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/AMD/Include)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/COLAMD/Include)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/CHOLMOD/Include)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/UFconfig)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/PARAKLETE/Include)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/CAMD/Include)

  SET(PARAKLETE_HEADERS
    SuiteSparse/PARAKLETE/Include/amesos_paraklete_decl.h
    SuiteSparse/CHOLMOD/Include/amesos_cholmod_complexity.h
    SuiteSparse/CCOLAMD/Include/amesos_ccolamd.h
    SuiteSparse/CHOLMOD/Include/amesos_cholmod_blas.h
    SuiteSparse/CHOLMOD/Include/amesos_cholmod_cholesky.h
    SuiteSparse/CHOLMOD/Include/amesos_cholmod_config.h
    SuiteSparse/CHOLMOD/Core/amesos_t_cholmod_dense.c
    SuiteSparse/CHOLMOD/Include/amesos_cholmod_template.h
    SuiteSparse/CHOLMOD/Core/amesos_t_cholmod_change_factor.c
    SuiteSparse/CHOLMOD/Core/amesos_t_cholmod_transpose.c
    SuiteSparse/CHOLMOD/Core/amesos_t_cholmod_triplet.c
    SuiteSparse/CHOLMOD/Cholesky/amesos_t_cholmod_solve.c
    SuiteSparse/CHOLMOD/Cholesky/amesos_t_cholmod_lsolve.c
    SuiteSparse/CHOLMOD/Cholesky/amesos_t_cholmod_ltsolve.c
    SuiteSparse/CAMD/Include/amesos_camd.h
    SuiteSparse/CAMD/Include/amesos_camd_internal.h
    )


   IF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
                   IF(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 4.2)
                              SET_SOURCE_FILES_PROPERTIES(${PARAKLETE_HEADERS},
                                PROPERTIES
                                COMPILE_FLAGS "-Wno-all -Wno-pedantic")
                            ENDIF()
   ELSEIF (WIN32 AND NOT CYGWIN)
       # No flags
   ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "PGI")
      #No flags
   ELSE()
        SET_SOURCE_FILES_PROPERTIES(${PARAKLETE_HEADERS},
                                PROPERTIES
                                COMPILE_FLAGS "-Wno-all ")
   ENDIF()
  


   SET(HEADERS ${HEADERS}
       ${PARAKLETE_KLU_COMMON_H}
       Amesos_Paraklete.h
       ${PARAKLETE_HEADERS}
  )

  SET(PARAKLETE_SOURCE
        SuiteSparse/PARAKLETE/Source/amesos_paraklete_analyze.c
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_btf.c
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_error.c
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_factorize.c
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_finish.c
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_kernel.c
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_lsolve_node.c 
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_node.c
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_reanalyze.c
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_solve.c
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_start.c
    SuiteSparse/PARAKLETE/Source/amesos_paraklete_usolve_node.c 
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_common.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_dense.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_factor.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_change_factor.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_memory.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_complex.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_transpose.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_sparse.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_band.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_copy.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_triplet.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_error.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_aat.c
    SuiteSparse/CHOLMOD/Core/amesos_cholmod_l_add.c
    SuiteSparse/CHOLMOD/Check/amesos_cholmod_check.c
    SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_l_postorder.c
    SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_l_amd.c
    SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_l_colamd.c
    SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_l_etree.c
    SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_l_rowcolcounts.c
    SuiteSparse/CHOLMOD/Cholesky/amesos_cholmod_l_analyze.c
    SuiteSparse/CHOLMOD/Partition/amesos_cholmod_l_ccolamd.c
    SuiteSparse/CHOLMOD/Partition/amesos_cholmod_l_camd.c
    SuiteSparse/CHOLMOD/Partition/amesos_cholmod_l_csymamd.c
    SuiteSparse/CHOLMOD/Partition/amesos_cholmod_l_metis.c

=== packages/amesos2/example/CMakeLists.txt ===

# TRIBITS_ADD_EXECUTABLE_AND_TEST(
#   SimpleSolveExample
#   SOURCES SimpleSolve
#   ARGS
#   COMM serial mpi
# )

# TRIBITS_ADD_EXECUTABLE_AND_TEST(
#   SimpleSolveFileExample
#   SOURCES SimpleSolve_File
#   ARGS
#   COMM serial mpi
# )

# TRIBITS_ADD_EXECUTABLE_AND_TEST(
#   MultipleSolvesFileExample
#   SOURCES MultipleSolves_File
#   ARGS
#   COMM serial mpi
# )

# TRIBITS_ADD_EXECUTABLE_AND_TEST(
#   SimpleSolveWithParameters
#   SOURCES SimpleSolve_WithParameters
#   ARGS
#   COMM serial mpi
# )

# TRIBITS_ADD_EXECUTABLE_AND_TEST(
#   ComplexSolveWithTranspose
#   SOURCES ComplexSolve_WithTranspose
#   ARGS
#   COMM serial mpi
# )

# TRIBITS_ADD_EXECUTABLE(
#   TwoPartSolveExample
#   SOURCES TwoPartSolve
#   )


IF (Tpetra_INST_INT_INT)
TRIBITS_ADD_EXECUTABLE(
  QuickSolve
  SOURCES quick_solve
  )
ENDIF ()

IF (Tpetra_INST_INT_INT)
IF (${PACKAGE_NAME}_ENABLE_EpetraExt)
  TRIBITS_ADD_EXECUTABLE(
    QuickSolveEpetra
    SOURCES quick_solve_epetra
  )
ENDIF()
ENDIF()

IF (Tpetra_INST_INT_INT)
TRIBITS_COPY_FILES_TO_BINARY_DIR(Amesos2_SimpleSolve_File
  SOURCE_FILES arc130.mtx
  SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../test/matrices/
  DEST_DIR ${CMAKE_CURRENT_BINARY_DIR}
  )
ENDIF()

=== packages/amesos2/src/CMakeLists.txt ===
# @HEADER
#
# ***********************************************************************
#
#           Amesos2: Templated Direct Sparse Solver Package
#                  Copyright 2011 Sandia Corporation
#
# Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
# the U.S. Government retains certain rights in this software.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# 3. Neither the name of the Corporation nor the names of the
# contributors may be used to endorse or promote products derived from
# this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY SANDIA CORPORATION "AS IS" AND ANY
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL SANDIA CORPORATION OR THE
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
# Questions? Contact Michael A. Heroux (maherou@sandia.gov)
#
# ***********************************************************************
#
# @HEADER



#
# A) Package-specific configuration options
#

TRIBITS_CONFIGURE_FILE(${PACKAGE_NAME}_config.h)

#
# B) Define the header and source files (and include directories)
#

SET(HEADERS "")
SET(SOURCES "")

# Set the base Trilinos directory in order to find Trilinos_version.h

ASSERT_DEFINED(PROJECT_SOURCE_DIR)

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR})

# If we use Trilinos_version then "make install" will fail.
#APPEND_SET(HEADERS
#${PROJECT_SOURCE_DIR}/Trilinos_version.h
#  )

# Set headers (for IDEs and installing)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

APPEND_SET(HEADERS
  ${CMAKE_CURRENT_BINARY_DIR}/${PACKAGE_NAME}_config.h
  )

# NOTE: Above, we add the XXX_config.h file so that MS Visual Studio
# will know to include this file in the dependency analysis

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/basker)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/KLU2/Include)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/SuiteSparse/KLU2/Source)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../../amesos/src/SuiteSparse/AMD/Include)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../../amesos/src/SuiteSparse/COLAMD/Include)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../../amesos/src/SuiteSparse/BTF/Include)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/../../amesos/src/SuiteSparse/UFconfig)

APPEND_SET(HEADERS
  Amesos2.hpp
  Amesos2_AbstractConcreteMatrixAdapter_def.hpp
  Amesos2_Control.hpp
  Amesos2_Details_LinearSolverFactory.hpp
  Amesos2_Details_LinearSolverFactory_decl.hpp
  Amesos2_Details_LinearSolverFactory_def.hpp
  Amesos2_Details_registerLinearSolverFactory.hpp
  Amesos2_Factory.hpp
  Amesos2_FunctionMap.hpp
  Amesos2_TpetraRowMatrix_AbstractMatrixAdapter.hpp
  Amesos2_TpetraRowMatrix_AbstractMatrixAdapter_decl.hpp
  Amesos2_TpetraRowMatrix_AbstractMatrixAdapter_def.hpp
  Amesos2_TpetraCrsMatrix_MatrixAdapter.hpp
  Amesos2_TpetraCrsMatrix_MatrixAdapter_decl.hpp
  Amesos2_TpetraCrsMatrix_MatrixAdapter_def.hpp
  Amesos2_MatrixAdapter.hpp
  Amesos2_MatrixAdapter_decl.hpp
  Amesos2_MatrixAdapter_def.hpp
  Amesos2_AbstractConcreteMatrixAdapter.hpp
  Amesos2_ctassert.hpp
  Amesos2_ConcreteMatrixAdapter.hpp
  Amesos2_ConcreteMatrixAdapter_decl.hpp
  Amesos2_ConcreteMatrixAdapter_def.hpp
  Amesos2_MatrixHelper.hpp
  Amesos2_MatrixTraits.hpp
  Amesos2_Meta.hpp
  Amesos2_MultiVecAdapter.hpp
  Amesos2_MultiVecAdapter_decl.hpp
  Amesos2_MultiVecAdapter_def.hpp
  Amesos2_Solver.hpp
  Amesos2_Solver_decl.hpp
  Amesos2_SolverCore.hpp
  Amesos2_SolverCore_decl.hpp
  Amesos2_SolverCore_def.hpp
  Amesos2_SolverTraits.hpp
  Amesos2_Status.hpp
  Amesos2_Timers.hpp
  Amesos2_TpetraMultiVecAdapter.hpp
  Amesos2_TpetraMultiVecAdapter_decl.hpp
  Amesos2_TpetraMultiVecAdapter_def.hpp
  Amesos2_TypeMap.hpp
  Amesos2_TypeDecl.hpp
  Amesos2_Util.hpp
  Amesos2_Version.hpp
  )

# Set sources

APPEND_SET(SOURCES
  Amesos2_Control.cpp
  Amesos2_Details_LinearSolverFactory.cpp
  Amesos2_Details_registerLinearSolverFactory.cpp
  Amesos2_Factory.cpp
  Amesos2_MatrixAdapter.cpp
  Amesos2_ConcreteMatrixAdapter.cpp
  Amesos2_MultiVecAdapter.cpp
  Amesos2_SolverCore.cpp
  Amesos2_Solver.cpp
  Amesos2_TpetraRowMatrix_AbstractMatrixAdapter.cpp
  Amesos2_TpetraCrsMatrix_MatrixAdapter.cpp
  Amesos2_TpetraMultiVecAdapter.cpp
  Amesos2_Util.cpp
  Amesos2_Version.cpp
  )

# Set additional headers and sources based on package-specific
# configuration options.  In Amesos2, each solver interface should be
# added only if that solver has been enabled by the user.

SET(AMESOS2_CU_SOURCES "")

IF (${PACKAGE_NAME}_ENABLE_LAPACK)
  APPEND_SET(HEADERS
    Amesos2_Lapack.hpp
    Amesos2_Lapack_decl.hpp
    Amesos2_Lapack_def.hpp
    )

  APPEND_SET(SOURCES
    Amesos2_Lapack.cpp
    )
ENDIF()

IF (${PACKAGE_NAME}_ENABLE_KLU2)

  APPEND_SET(HEADERS
    Amesos2_KLU2.hpp
    Amesos2_KLU2_decl.hpp
    Amesos2_KLU2_def.hpp
    Amesos2_KLU2_FunctionMap.hpp
    Amesos2_KLU2_TypeMap.hpp
    )

   APPEND_SET(SOURCES
     Amesos2_KLU2_TypeMap.cpp
     )

   APPEND_SET(SOURCES
      Amesos2_KLU2.cpp
      )


   SET(KLU_HEADERS
        SuiteSparse/KLU2/Source/klu2_analyze_given.hpp
        SuiteSparse/KLU2/Source/klu2_analyze.hpp
        SuiteSparse/KLU2/Source/klu2_defaults.hpp
        SuiteSparse/KLU2/Source/klu2_diagnostics.hpp
        SuiteSparse/KLU2/Source/klu2_dump.hpp
        SuiteSparse/KLU2/Source/klu2_extract.hpp
        SuiteSparse/KLU2/Source/klu2_factor.hpp
        SuiteSparse/KLU2/Source/klu2_free_numeric.hpp
        SuiteSparse/KLU2/Source/klu2_free_symbolic.hpp
        SuiteSparse/KLU2/Source/klu2_refactor.hpp
        SuiteSparse/KLU2/Source/klu2.hpp
        SuiteSparse/KLU2/Source/klu2_kernel.hpp
        SuiteSparse/KLU2/Source/klu2_memory.hpp
        SuiteSparse/KLU2/Source/klu2_refactor.hpp
        SuiteSparse/KLU2/Source/klu2_scale.hpp
        SuiteSparse/KLU2/Source/klu2_solve.hpp
        SuiteSparse/KLU2/Source/klu2_sort.hpp
        SuiteSparse/KLU2/Source/klu2_tsolve.hpp
        SuiteSparse/KLU2/Include/klu2_ext.hpp
        SuiteSparse/KLU2/Include/klu2.h
        SuiteSparse/KLU2/Include/klu2_internal.h
        SuiteSparse/KLU2/Include/klu2_ordinaltraits.h
        SuiteSparse/KLU2/Include/klu2_scalartraits.h
        SuiteSparse/KLU2/Include/klu2_version.h
     )

     #IF(CMAKE_COMPILER_IS_GNUCC OR CMAKE_COMPILER_IS_GNUCXX)
              SET_SOURCE_FILES_PROPERTIES(${KLU_HEADERS},
              PROPERTIES
              COMPILE_FLAGS "-Wno-shadow")


    APPEND_SET(HEADERS
        SuiteSparse/KLU2/Source/klu2_analyze_given.hpp
        SuiteSparse/KLU2/Source/klu2_analyze.hpp
        SuiteSparse/KLU2/Source/klu2_defaults.hpp
        SuiteSparse/KLU2/Source/klu2_diagnostics.hpp
        SuiteSparse/KLU2/Source/klu2_dump.hpp
        SuiteSparse/KLU2/Source/klu2_extract.hpp
        SuiteSparse/KLU2/Source/klu2_factor.hpp
        SuiteSparse/KLU2/Source/klu2_free_numeric.hpp
        SuiteSparse/KLU2/Source/klu2_free_symbolic.hpp
        SuiteSparse/KLU2/Source/klu2_refactor.hpp
        SuiteSparse/KLU2/Source/klu2.hpp
        SuiteSparse/KLU2/Source/klu2_kernel.hpp
        SuiteSparse/KLU2/Source/klu2_memory.hpp
        SuiteSparse/KLU2/Source/klu2_refactor.hpp
        SuiteSparse/KLU2/Source/klu2_scale.hpp
        SuiteSparse/KLU2/Source/klu2_solve.hpp
        SuiteSparse/KLU2/Source/klu2_sort.hpp
        SuiteSparse/KLU2/Source/klu2_tsolve.hpp
        SuiteSparse/KLU2/Include/klu2_ext.hpp
        SuiteSparse/KLU2/Include/klu2.h
        SuiteSparse/KLU2/Include/klu2_internal.h
        SuiteSparse/KLU2/Include/klu2_ordinaltraits.h
        SuiteSparse/KLU2/Include/klu2_scalartraits.h
        SuiteSparse/KLU2/Include/klu2_version.h
     )

ENDIF()

IF (${PACKAGE_NAME}_ENABLE_Basker)
  APPEND_SET(HEADERS
    Amesos2_Basker.hpp
    Amesos2_Basker_decl.hpp
    Amesos2_Basker_def.hpp
    Amesos2_Basker_FunctionMap.hpp
    Amesos2_Basker_TypeMap.hpp
    )

   APPEND_SET(SOURCES
     Amesos2_Basker_TypeMap.cpp
     )

   APPEND_SET(SOURCES
      Amesos2_Basker.cpp
      )

    APPEND_SET(HEADERS
        basker/basker.hpp
        basker/basker_decl.hpp
        basker/basker_def.hpp
        basker/basker_scalartraits.hpp
        basker/basker_types.hpp
     )

ENDIF()

IF (${PACKAGE_NAME}_ENABLE_SuperLU)

  APPEND_SET(HEADERS
    Amesos2_Superlu.hpp
    Amesos2_Superlu_decl.hpp
    Amesos2_Superlu_def.hpp
    Amesos2_Superlu_FunctionMap.hpp
    Amesos2_Superlu_TypeMap.hpp
    )

  APPEND_SET(SOURCES
    Amesos2_Superlu_TypeMap.cpp
    Amesos2_Superlu.cpp
    )

ENDIF()

IF (${PACKAGE_NAME}_ENABLE_SuperLUMT)
  APPEND_SET(HEADERS
    Amesos2_Superlumt.hpp
    Amesos2_Superlumt_FunctionMap.hpp
    Amesos2_Superlumt_TypeMap.hpp
    Amesos2_Superlumt_decl.hpp
    Amesos2_Superlumt_def.hpp
    )

  APPEND_SET(SOURCES
    Amesos2_Superlumt.cpp
    Amesos2_Superlumt_TypeMap.cpp
    )
ENDIF()

IF (${PACKAGE_NAME}_ENABLE_SuperLUDist) # This naming syntax is consistent with Trilinos
  APPEND_SET(HEADERS
    Amesos2_Superludist.hpp
    Amesos2_Superludist_FunctionMap.hpp
    Amesos2_Superludist_TypeMap.hpp
    Amesos2_Superludist_decl.hpp
    Amesos2_Superludist_def.hpp
    )

  APPEND_SET(SOURCES
    Amesos2_Superludist.cpp
#    Amesos2_Superludist_TypeMap.cpp
    )
ENDIF()

IF (${PACKAGE_NAME}_ENABLE_PARDISO_MKL)
  APPEND_SET(HEADERS
    Amesos2_PardisoMKL.hpp
    Amesos2_PardisoMKL_FunctionMap.hpp
    Amesos2_PardisoMKL_TypeMap.hpp
    Amesos2_PardisoMKL_decl.hpp
    Amesos2_PardisoMKL_def.hpp
    )

  APPEND_SET(SOURCES
    Amesos2_PardisoMKL.cpp
  )
ENDIF()

IF (${PACKAGE_NAME}_ENABLE_MUMPS)
   APPEND_SET(HEADERS
   Amesos2_MUMPS.hpp
   Amesos2_MUMPS_FunctionMap.hpp
   Amesos2_MUMPS_TypeMap.hpp
   Amesos2_MUMPS_decl.hpp
   Amesos2_MUMPS_def.hpp
   )

   APPEND_SET(SOURCES
   Amesos2_MUMPS.cpp
   Amesos2_MUMPS_TypeMap.cpp
   )
ENDIF()


IF (Tpetra_INST_INT_INT)
IF (${PACKAGE_NAME}_ENABLE_Epetra)
  APPEND_SET(HEADERS
    Amesos2_EpetraRowMatrix_AbstractMatrixAdapter.hpp
    Amesos2_EpetraRowMatrix_AbstractMatrixAdapter_decl.hpp
    Amesos2_EpetraRowMatrix_AbstractMatrixAdapter_def.hpp
    Amesos2_EpetraCrsMatrix_MatrixAdapter.hpp
    Amesos2_EpetraCrsMatrix_MatrixAdapter_decl.hpp
    Amesos2_EpetraCrsMatrix_MatrixAdapter_def.hpp
    Amesos2_EpetraMultiVecAdapter.hpp
    Amesos2_EpetraMultiVecAdapter_decl.hpp
    Amesos2_EpetraMultiVecAdapter_def.hpp
    )

  APPEND_SET(SOURCES
    # Amesos2_EpetraCrsMatrixAdapter.cpp
    # Amesos2_EpetraJadMatrixAdapter.cpp
    # Amesos2_EpetraMsrMatrixAdapter.cpp
    # Amesos2_EpetraRowMatrixAdapter.cpp
    # Amesos2_EpetraVbrMatrixAdapter.cpp
    Amesos2_EpetraRowMatrix_AbstractMatrixAdapter.cpp
    Amesos2_EpetraCrsMatrix_MatrixAdapter.cpp
    Amesos2_EpetraMultiVecAdapter.cpp
    )
ENDIF()
ENDIF()

IF (Trilinos_ENABLE_Amesos)
    ADD_SUBDIRECTORY(SuiteSparse/KLU2/Source)
ENDIF()

IF (${PACKAGE_NAME}_ENABLE_Experimental)
   IF (${PACKAGE_NAME}_ENABLE_Cholmod)
      APPEND_SET(HEADERS
        Amesos2_Cholmod.hpp
        Amesos2_Cholmod_decl.hpp
        Amesos2_Cholmod_def.hpp

=== packages/ifpack2/src/CMakeLists.txt ===
INCLUDE(TrilinosCreateClientTemplateHeaders)

# Function to generate ETI (explicit template instantiation) files
# from a template and list of class names
FUNCTION(IFPACK2_PROCESS_ETI_TEMPLATE ETI_CLASSES TEMPLATE_FILE PROCESSED_FILE SOURCES_LIST)
  SET(SRCS "")
  FOREACH(CLASS ${ETI_CLASSES})
    string(REPLACE "::" "_" CLASS_FILE_NAME "${CLASS}")
    string(TOUPPER "${CLASS_FILE_NAME}" UPPER_CASE_CLASS)
    string(REPLACE "CLASS_FILE_NAME" "${CLASS_FILE_NAME}" FINAL_FILE_NAME "${PROCESSED_FILE}")
    CONFIGURE_FILE(${TEMPLATE_FILE} ${FINAL_FILE_NAME})
    SET(SRCS ${SRCS} ${FINAL_FILE_NAME})
  ENDFOREACH()
  SET(${SOURCES_LIST} ${SRCS} PARENT_SCOPE)
ENDFUNCTION(IFPACK2_PROCESS_ETI_TEMPLATE)

# Function that follows the Tpetra convention for mangling C++ types
# so that they can be used as C preprocessor macro arguments.
FUNCTION(IFPACK2_MANGLE_TEMPLATE_PARAMETER TYPE_MANGLED_OUT TYPE_IN)
  STRING(REPLACE "<" "0" TMP0 "${TYPE_IN}")
  STRING(REPLACE ">" "0" TMP1 "${TMP0}")
  STRING(REPLACE "::" "_" TMP2 "${TMP1}")
  # Spaces (as in "long long") get squished out.
  STRING(REPLACE " " "" TMP3 "${TMP2}")
  SET(${TYPE_MANGLED_OUT} ${TMP3} PARENT_SCOPE)
ENDFUNCTION(IFPACK2_MANGLE_TEMPLATE_PARAMETER)

# Function that turns a valid Scalar template parameter into a macro
# name (all caps, with no white space and no punctuation other than
# underscore).
FUNCTION(IFPACK2_SCALAR_MACRO_NAME NAME_OUT NAME_IN)
  STRING(COMPARE EQUAL "${NAME_IN}" "__float128" IS_FLOAT128)
  IF(IS_FLOAT128)
    # __float128 is a special case; we remove the __ from the macro name.
    SET(${NAME_OUT} "FLOAT128" PARENT_SCOPE)
  ELSE()
    STRING(COMPARE EQUAL "${NAME_IN}" "std::complex<float>" IS_COMPLEX_FLOAT)
    IF(IS_COMPLEX_FLOAT)
      SET(${NAME_OUT} "COMPLEX_FLOAT" PARENT_SCOPE)
    ELSE()
      STRING(COMPARE EQUAL "${NAME_IN}" "std::complex<double>" IS_COMPLEX_DOUBLE)
      IF(IS_COMPLEX_DOUBLE)
        SET(${NAME_OUT} "COMPLEX_DOUBLE" PARENT_SCOPE)
      ELSE()
        # Convert to upper case, convert double colons to underscores,
        # and hope for the best.
        #
        # It would be nice if CMake were consistent about where output
        # arguments go.  Alas, this is not to be.  TOUPPER puts the
        # output argument last; REPLACE puts it after the search and
        # substitute strings, before the input string.
        STRING(TOUPPER "${NAME_IN}" TMP0)
        STRING(REPLACE "::" "_" TMP1 "${TMP0}")
        SET(${NAME_OUT} ${TMP1} PARENT_SCOPE)
      ENDIF()
    ENDIF()
  ENDIF()
ENDFUNCTION(IFPACK2_SCALAR_MACRO_NAME)

# Function that turns a valid LocalOrdinal or GlobalOrdinal template
# parameter (which must be a C++ built-in integer type) into a macro
# name (all caps, with no white space and no punctuation other than
# underscore).
FUNCTION(IFPACK2_ORDINAL_MACRO_NAME NAME_OUT NAME_IN)
  # It would be nice if CMake were consistent about where output
  # arguments go.  Alas, this is not to be.  TOUPPER puts the
  # output argument last; REPLACE puts it after the search and
  # substitute strings, before the input string.
  #
  # "long long" -> "LONG LONG"
  STRING(TOUPPER "${NAME_IN}" TMP0)
  # "LONG LONG" -> "LONG_LONG"
  STRING(REPLACE " " "_" TMP1 "${TMP0}")
  SET(${NAME_OUT} ${TMP1} PARENT_SCOPE)
ENDFUNCTION(IFPACK2_ORDINAL_MACRO_NAME)

# Function that turns a valid Node template parameter into a macro
# name (all caps, with no white space and no punctuation other than
# underscore).
FUNCTION(IFPACK2_NODE_MACRO_NAME NAME_OUT NAME_IN)
  STRING(REGEX MATCH "Kokkos::Compat::Kokkos(.*)WrapperNode" TMP0 "${NAME_IN}")
  STRING(COMPARE EQUAL "${TMP0}" "" DOES_NOT_MATCH)
  IF(DOES_NOT_MATCH)
    MESSAGE(FATAL_ERROR "Ifpack2: Node $NAME_IN is not a supported Node type.")
  ELSE()
    # Extract the Kokkos execution space (KOKKOS_EXEC_SPACE) from the Node name.
    STRING(REGEX REPLACE "Kokkos::Compat::Kokkos(.*)WrapperNode" "\\1" KOKKOS_EXEC_SPACE "${NAME_IN}")

    # Special case: Threads.  The macro name unfortunately differs
    # from the execution space name in a way that doesn't fit the
    # pattern of the other execution spaces.
    STRING(COMPARE EQUAL "${KOKKOS_EXEC_SPACE}" "Threads" IS_THREADS)
    IF(IS_THREADS)
      SET(${NAME_OUT} "PTHREAD" PARENT_SCOPE)
    ELSE()
      # The other cases (Cuda, Serial, OpenMP) are easy.
      STRING(TOUPPER "${KOKKOS_EXEC_SPACE}" NAME_OUT_TMP)
      SET(${NAME_OUT} ${NAME_OUT_TMP} PARENT_SCOPE)
    ENDIF()
  ENDIF()
ENDFUNCTION(IFPACK2_NODE_MACRO_NAME)

# Function to generate one .cpp file for the given (Scalar,
# LocalOrdinal, GlobalOrdinal, Node) template parameter combination,
# for run-time registration of Ifpack2's LinearSolverFactory over
# those template parameters.  This is meant to be called by
# IFPACK2_PROCESS_ALL_FACTORY_TEMPLATES.  This function takes the
# names already mangled, to avoid unnecessary string processing
# overhead.
FUNCTION(IFPACK2_PROCESS_ONE_FACTORY_TEMPLATE OUTPUT_FILE TEMPLATE_FILE SC LO GO NT SC_MANGLED LO_MANGLED GO_MANGLED NT_MANGLED SC_MACRO_NAME LO_MACRO_NAME GO_MACRO_NAME NT_MACRO_NAME)
  STRING(REPLACE ".tmpl" "_${SC_MACRO_NAME}_${LO_MACRO_NAME}_${GO_MACRO_NAME}_${NT_MACRO_NAME}.cpp" OUT_FILE "${TEMPLATE_FILE}")
  CONFIGURE_FILE("${TEMPLATE_FILE}" "${OUT_FILE}")

  SET(${OUTPUT_FILE} ${OUT_FILE} PARENT_SCOPE)
ENDFUNCTION(IFPACK2_PROCESS_ONE_FACTORY_TEMPLATE)

# Function to generate .cpp files for run-time registration of
# Ifpack2's LinearSolverFactory, from a template.  We generate one
# .cpp file for each (Scalar, LocalOrdinal, GlobalOrdinal, Node) type
# combination over which Ifpack2 does tests and/or ETI.
FUNCTION(IFPACK2_PROCESS_ALL_FACTORY_TEMPLATES OUTPUT_FILES TEMPLATE_FILE SCALAR_TYPES LOCALORDINAL_TYPES GLOBALORDINAL_TYPES NODE_TYPES)
  SET(OUT_FILES "")
  FOREACH(NT ${NODE_TYPES})
    IFPACK2_MANGLE_TEMPLATE_PARAMETER(NT_MANGLED "${NT}")
    IFPACK2_NODE_MACRO_NAME(NT_MACRO_NAME "${NT}")
    FOREACH(GO ${GLOBALORDINAL_TYPES})
      IFPACK2_MANGLE_TEMPLATE_PARAMETER(GO_MANGLED "${GO}")
      IFPACK2_ORDINAL_MACRO_NAME(GO_MACRO_NAME "${GO}")
      FOREACH(LO ${LOCALORDINAL_TYPES})
        IFPACK2_MANGLE_TEMPLATE_PARAMETER(LO_MANGLED "${LO}")
        IFPACK2_ORDINAL_MACRO_NAME(LO_MACRO_NAME "${LO}")
        FOREACH(SC ${SCALAR_TYPES})
          IFPACK2_MANGLE_TEMPLATE_PARAMETER(SC_MANGLED "${SC}")
          IFPACK2_SCALAR_MACRO_NAME(SC_MACRO_NAME "${SC}")
          IFPACK2_PROCESS_ONE_FACTORY_TEMPLATE(OUT_FILE "${TEMPLATE_FILE}" "${SC}" "${LO}" "${GO}" "${NT}" "${SC_MANGLED}" "${LO_MANGLED}" "${GO_MANGLED}" "${NT_MANGLED}" "${SC_MACRO_NAME}" "${LO_MACRO_NAME}" "${GO_MACRO_NAME}" "${NT_MACRO_NAME}")
          LIST(APPEND OUT_FILES ${OUT_FILE})
        ENDFOREACH() # SC
      ENDFOREACH() # LO
    ENDFOREACH() # GO
  ENDFOREACH() # NT

  # This is the standard CMake idiom for setting an output variable so
  # that the caller can see the result.
  SET(${OUTPUT_FILES} ${OUT_FILES} PARENT_SCOPE)
ENDFUNCTION(IFPACK2_PROCESS_ALL_FACTORY_TEMPLATES)

#
# A) Package-specific configuration options
#

TRIBITS_CONFIGURE_FILE(${PACKAGE_NAME}_config.h)

#
# B) Define the header and source files (and directories)
#

#
# src
#

SET(HEADERS "")
SET(SOURCES "")

SET_AND_INC_DIRS(DIR ${CMAKE_CURRENT_SOURCE_DIR})
APPEND_GLOB(HEADERS ${DIR}/*.hpp)
APPEND_GLOB(SOURCES ${DIR}/*.cpp)
TRILINOS_CREATE_CLIENT_TEMPLATE_HEADERS(${DIR})

# SupportGraph requires some TPLs and options to be enabled.
IF (${PACKAGE_NAME}_ENABLE_Experimental AND ${PACKAGE_NAME}_ENABLE_Lemon AND ${PACKAGE_NAME}_ENABLE_Amesos2 AND ${PACKAGE_NAME}_ENABLE_Cholmod)
  TRILINOS_CREATE_CLIENT_TEMPLATE_HEADERS(${DIR}/supportgraph)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/supportgraph)
  SET(HEADERS ${HEADERS}
    supportgraph/Ifpack2_SupportGraph_decl.hpp
    supportgraph/Ifpack2_SupportGraph_def.hpp
    )
  SET(SOURCES ${SOURCES}
    supportgraph/Ifpack2_SupportGraph.cpp
    )
ENDIF()

# Must glob the binary dir last to get all of the auto-generated headers
SET_AND_INC_DIRS(DIR ${CMAKE_CURRENT_BINARY_DIR})
APPEND_GLOB(HEADERS ${DIR}/*.hpp)
APPEND_SET(HEADERS ${DIR}/${PACKAGE_NAME}_config.h )
APPEND_SET(HEADERS ${DIR}/${PACKAGE_NAME}_ETIHelperMacros.h )

# Automatically generate ETI (explicit template instanatiation) files
# for Node types that use the (new) Kokkos Devices.
SET(IFPACK2_CPP_SOURCES "")
IF(Ifpack2_ENABLE_EXPLICIT_INSTANTIATION)
  # Set the list of Ifpack2 classes templated on <Scalar, LO, GO,
  # Node> for which we want to do ETI using this system.  These
  # classes usually operate on sparse matrices (instances of
  # Tpetra::CrsMatrix or Tpetra::RowMatrix, which also take these
  # template parameters).
  GLOBAL_SET(IFPACK2_ETI_CLASSES
    AdditiveSchwarz
    BlockRelaxation
    BorderedOperator
    Chebyshev
    BandedContainer
    DenseContainer
    TriDiContainer
    Diagonal
    DiagonalFilter
    DropFilter
    Factory
    Hiptmair
    IdentitySolver
    ILUT
    Krylov
    LocalFilter
    OverlappingRowMatrix
    Relaxation
    ReorderFilter
    RILUK
    SingletonFilter
    SparseContainer
    SparsityFilter
    LinePartitioner
    Details::Chebyshev
    Details::DenseSolver
    Details::Factory
    Details::LinearSolver
    Details::OneLevelFactory
    Details::TriDiSolver
    Experimental::RBILUK
    )
  IF(Ifpack2_ENABLE_Amesos2)
    APPEND_GLOBAL_SET(IFPACK2_ETI_CLASSES
      Details::Amesos2Wrapper
      )
  ENDIF()

  # Set the list of Ifpack2 classes templated on <LO, GO, Node> for
  # which we want to do ETI using this system.  These classes usually
  # operate on sparse graphs (instances of Tpetra::CrsGraph or
  # Tpetra::RowGraph, which also take these template parameters).
  GLOBAL_SET(IFPACK2_ETI_LO_GO_CLASSES
    LinearPartitioner
    OverlappingPartitioner
    Details::OverlappingRowGraph
    )

  # ETI for the Kokkos::Serial device.
  IF (Tpetra_INST_SERIAL)
    IFPACK2_PROCESS_ETI_TEMPLATE(
      "${IFPACK2_ETI_CLASSES}"
      Ifpack2_ETI_SC_LO_GO_Serial.tmpl
      "Ifpack2_CLASS_FILE_NAME_Serial.cpp"
      IFPACK2_SRCS)
    LIST(APPEND IFPACK2_CPP_SOURCES ${IFPACK2_SRCS})
    IFPACK2_PROCESS_ETI_TEMPLATE(
      "${IFPACK2_ETI_LO_GO_CLASSES}"
      Ifpack2_ETI_LO_GO_Serial.tmpl
      "Ifpack2_CLASS_FILE_NAME_Serial.cpp"
      IFPACK2_SRCS)
    LIST(APPEND IFPACK2_CPP_SOURCES ${IFPACK2_SRCS})
  ENDIF()

  # ETI for the Kokkos::Classic::Serialnode device.
  IF (Tpetra_INST_SERIALCLASSIC)
    IFPACK2_PROCESS_ETI_TEMPLATE(
      "${IFPACK2_ETI_CLASSES}"
      Ifpack2_ETI_SC_LO_GO_Classic.tmpl
      "Ifpack2_CLASS_FILE_NAME_Classic.cpp"
      IFPACK2_SRCS)
    LIST(APPEND IFPACK2_CPP_SOURCES ${IFPACK2_SRCS})
    IFPACK2_PROCESS_ETI_TEMPLATE(
      "${IFPACK2_ETI_LO_GO_CLASSES}"
      Ifpack2_ETI_LO_GO_Classic.tmpl
      "Ifpack2_CLASS_FILE_NAME_Classic.cpp"
      IFPACK2_SRCS)
    LIST(APPEND IFPACK2_CPP_SOURCES ${IFPACK2_SRCS})
  ENDIF()

  # ETI for the Kokkos::Threads device.
  IF (Tpetra_INST_PTHREAD)
    IFPACK2_PROCESS_ETI_TEMPLATE(
      "${IFPACK2_ETI_CLASSES}"
      Ifpack2_ETI_SC_LO_GO_Threads.tmpl
      "Ifpack2_CLASS_FILE_NAME_Threads.cpp"
      IFPACK2_SRCS)
    LIST(APPEND IFPACK2_CPP_SOURCES ${IFPACK2_SRCS})
    IFPACK2_PROCESS_ETI_TEMPLATE(
      "${IFPACK2_ETI_LO_GO_CLASSES}"
      Ifpack2_ETI_LO_GO_Threads.tmpl
      "Ifpack2_CLASS_FILE_NAME_Threads.cpp"
      IFPACK2_SRCS)
    LIST(APPEND IFPACK2_CPP_SOURCES ${IFPACK2_SRCS})
  ENDIF()

  # ETI for the Kokkos::OpenMP device.
  IF (Tpetra_INST_OPENMP)
    IFPACK2_PROCESS_ETI_TEMPLATE(
      "${IFPACK2_ETI_CLASSES}"
      Ifpack2_ETI_SC_LO_GO_OpenMP.tmpl
      "Ifpack2_CLASS_FILE_NAME_OpenMP.cpp"
      IFPACK2_SRCS)
    LIST(APPEND IFPACK2_CPP_SOURCES ${IFPACK2_SRCS})
    IFPACK2_PROCESS_ETI_TEMPLATE(
      "${IFPACK2_ETI_LO_GO_CLASSES}"
      Ifpack2_ETI_LO_GO_OpenMP.tmpl
      "Ifpack2_CLASS_FILE_NAME_OpenMP.cpp"
      IFPACK2_SRCS)
    LIST(APPEND IFPACK2_CPP_SOURCES ${IFPACK2_SRCS})
  ENDIF()

  # ETI for the Kokkos::Cuda device.
  IF (Tpetra_INST_CUDA)
    IFPACK2_PROCESS_ETI_TEMPLATE(
      "${IFPACK2_ETI_CLASSES}"

=== debian/changelog ===
trilinos (12.6.4-1) unstable; urgency=medium

  * New upstream release
  * Add myself to uploaders
  * Enable Kokkos build on 32-bit architectures (Closes: #835406)

 -- Graham Inggs <ginggs@debian.org>  Tue, 30 Aug 2016 11:46:35 +0200

trilinos (12.6.3-4) unstable; urgency=medium

  * Team upload
  * Only enable Kokkos assembly functions on amd64 (Closes: #815725)

 -- Graham Inggs <ginggs@debian.org>  Thu, 25 Aug 2016 12:33:23 +0200

trilinos (12.6.3-3) unstable; urgency=medium

  * Team upload
  * Use DEB_HOST_GNU_TYPE instead of DEB_HOST_MULTIARCH for BUILDDIR
  * Rebuild with GCC 6

 -- Graham Inggs <ginggs@debian.org>  Wed, 24 Aug 2016 14:01:43 +0200

=== debian/control ===
Source: trilinos
Homepage: http://trilinos.org
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Nico Schlömer <nico.schloemer@gmail.com>, Graham Inggs <ginggs@debian.org>
Build-Depends: debhelper (>= 9.20150628),
 cmake (>= 2.8.11),
 gfortran,
 libopenmpi-dev,
 libblas-dev,
 libboost-dev,
 libboost-system-dev,
 libboost-program-options-dev,
 libglm-dev,
 libhdf5-openmpi-dev,
 liblapack-dev,
 libmumps-dev (>= 4.10),
 libtbb-dev,
 zlib1g-dev
Build-Depends-Indep: doxygen,
 ghostscript,
 graphviz,
 libjs-mathjax,
 python,
 texlive-binaries,
 texlive-latex-base,
 texlive-latex-extra
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/trilinos.git
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/trilinos.git

Package: trilinos-all-dev
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${mydevpackages}
Suggests: trilinos-doc
Description: object-oriented framework for large-scale problems - development files (ALL)
 The Trilinos Project is an effort to develop algorithms and enabling
 technologies within an object-oriented software framework for the
 solution of large-scale, complex multi-physics engineering and
 scientific problems. A unique design feature of Trilinos is its
 focus on packages.
 .
 This package depends on all Trilinos development packages.

Package: trilinos-dev
Architecture: any
Section: libs
Depends: ${misc:Depends}
Suggests: trilinos-doc
Description: object-oriented framework for large-scale problems - development files
 The Trilinos Project is an effort to develop algorithms and enabling
 technologies within an object-oriented software framework for the
 solution of large-scale, complex multi-physics engineering and
 scientific problems. A unique design feature of Trilinos is its
 focus on packages.
 .
 This package contains the development header and some makefile templates.

Package: libtrilinos-amesos12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: direct sparse solver package - runtime files
 Amesos is the Direct Sparse Solver Package in Trilinos. The goal of Amesos is
 to make AX=B as easy as it sounds, at least for direct methods. Amesos
 provides clean and consistent interfaces to a number of third-party libraries.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-amesos-dev
Architecture: any
Section: libdevel
Depends: libmumps-dev, libtrilinos-amesos12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: direct sparse solver package - development files
 Amesos is the Direct Sparse Solver Package in Trilinos. The goal of Amesos is
 to make AX=B as easy as it sounds, at least for direct methods. Amesos
 provides clean and consistent interfaces to a number of third-party libraries.
 .
 This package provides headers.

Package: libtrilinos-amesos2-12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: next generation direct sparse solver package - runtime files
 Amesos2 is a package for solving sparse linear systems using direct solvers.
 It differs from Amesos in that it is templated on the scalar and index types.
 KLU2 is the only native solver.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-amesos2-dev
Architecture: any
Section: libdevel
Depends: libmumps-dev, libtrilinos-amesos2-12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: next generation direct sparse solver package - development files
 Amesos2 is a package for solving sparse linear systems using direct solvers.
 It differs from Amesos in that it is templated on the scalar and index types.
 KLU2 is the only native solver.
 .
 This package provides headers.

Package: libtrilinos-anasazi12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: large-scale eigenvalue algorithms - runtime files
 Anasazi is an extensible and interoperable framework for large-scale
 eigenvalue algorithms. The motivation for this framework is to provide a
 generic interface to a collection of algorithms for solving large-scale
 eigenvalue problems. Anasazi is interoperable because both the matrix and
 vectors (defining the eigenspace) are considered to be opaque objects -- only
 knowledge of the matrix and vectors via elementary operations is necessary.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-anasazi-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-anasazi12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: large-scale eigenvalue algorithms - development files
 Anasazi is an extensible and interoperable framework for large-scale
 eigenvalue algorithms. The motivation for this framework is to provide a
 generic interface to a collection of algorithms for solving large-scale
 eigenvalue problems. Anasazi is interoperable because both the matrix and
 vectors (defining the eigenspace) are considered to be opaque objects -- only
 knowledge of the matrix and vectors via elementary operations is necessary.
 .
 This package provides headers.

Package: libtrilinos-aztecoo12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: object-oriented interface to the Aztec solver - runtime files
 AztecOO provides an object-oriented interface to the well-known Aztec solver
 library. Furthermore, it allows flexible construction of matrix and vector
 arguments via Epetra matrix and vector classes. Finally, AztecOO provide
 additional functionality not found in Aztec and any future enhancements to the
 Aztec package will be available only through the AztecOO interfaces.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-aztecoo-dev
Architecture: any
Section: libdevel
Depends: liblapack-dev, libtrilinos-aztecoo12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: object-oriented interface to the Aztec solver - development files
 AztecOO provides an object-oriented interface to the well-known Aztec solver
 library. Furthermore, it allows flexible construction of matrix and vector
 arguments via Epetra matrix and vector classes. Finally, AztecOO provide
 additional functionality not found in Aztec and any future enhancements to the
 Aztec package will be available only through the AztecOO interfaces.
 .
 This package provides headers.

Package: libtrilinos-belos12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: iterative linear solvers - runtime files
 Belos provides next-generation iterative linear solvers and a powerful linear
 solver developer framework. This framework includes abstract interfaces to
 linear algebra using traits mechanisms, abstract interfaces to
 orthogonalization, abstract interfaces to iteration kernels, powerful solver
 managers, and a basic linear problem class.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-belos-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-belos12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: iterative linear solvers - development files
 Belos provides next-generation iterative linear solvers and a powerful linear
 solver developer framework. This framework includes abstract interfaces to
 linear algebra using traits mechanisms, abstract interfaces to
 orthogonalization, abstract interfaces to iteration kernels, powerful solver
 managers, and a basic linear problem class.
 .
 This package provides headers.

Package: libtrilinos-epetra12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: basis package for linear algebra - runtime files
 Epetra provides the fundamental construction routines and services function
 that are required for serial and parallel linear algebra libraries. Epetra
 provides the underlying foundation for all Trilinos solvers.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-epetra-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-epetra12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: basis package for linear algebra - development files
 Epetra provides the fundamental construction routines and services function
 that are required for serial and parallel linear algebra libraries. Epetra
 provides the underlying foundation for all Trilinos solvers.
 .
 This package provides headers.

Package: libtrilinos-epetraext12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: extensions to the Epetra toolkit - runtime files
 EpetraExt provides tools and functions that make it easier to work with
 Epetra.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-epetraext-dev
Architecture: any
Section: libdevel
Depends: libhdf5-openmpi-dev, libtrilinos-epetraext12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: extensions to the Epetra toolkit - development files
 EpetraExt provides tools and functions that make it easier to work with
 Epetra.
 .
 This package provides headers.

Package: libtrilinos-galeri12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: generation of distributed linear systems - runtime files
 The Trilinos package Galeri contains a suite of utilities and classes to
 generate a variety of (distributed) linear systems. Galeri's functionalities
 are very close to that of the MATLAB's gallery() function.
 Several well-known finite element and finite difference matrices can be
 generated using only a few simple code lines.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-galeri-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-galeri12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: generation of distributed linear systems - development files
 The Trilinos package Galeri contains a suite of utilities and classes to
 generate a variety of (distributed) linear systems. Galeri's functionalities
 are very close to that of the MATLAB's gallery() function.
 Several well-known finite element and finite difference matrices can be
 generated using only a few simple code lines.
 .
 This package provides headers.

Package: libtrilinos-globipack12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: 1D globalization capabilities - runtime files
 The GlobiPack package contains a set of interfaces and implementations for 1D
 globalization capabilities to be used in nonlinear solvers, optimization
 solvers, and similar algorithms that require globalization methods (e.g. line
 search and trust region methods). Basic interfaces and a few implementations
 are present for 1D line search methods appropritate for Newton, quasi-Newton,
 and nonlinear CG algorithms.
 .
 This package contains the dynamic libraries.

Package: libtrilinos-globipack-dev
Architecture: any
Section: libdevel
Depends: libtrilinos-globipack12 (= ${binary:Version}), trilinos-dev, ${misc:Depends}
Suggests: trilinos-doc
Description: 1D globalization capabilities - development files
 The GlobiPack package contains a set of interfaces and implementations for 1D
 globalization capabilities to be used in nonlinear solvers, optimization
 solvers, and similar algorithms that require globalization methods (e.g. line
 search and trust region methods). Basic interfaces and a few implementations
 are present for 1D line search methods appropritate for Newton, quasi-Newton,
 and nonlinear CG algorithms.
 .
 This package provides headers.

Package: libtrilinos-ifpack12
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: algebraic preconditioners - runtime files

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# dirnames deviate from package names...
LIB_PACKAGES = \
    amesos \
    amesos2 \
    anasazi \
    aztecoo \
    belos \
    epetra \
    epetraext \
    galeri \
    globipack \
    ifpack \
    ifpack2 \
    intrepid \
    isorropia \
    kokkos \
    komplex \
    ml \
    moertel \
    muelu \
    nox \
    optipack \
    pamgen \
    phalanx \
    pike \
    piro \
    pliris \
    rol \
    rtop \
    rythmos \
    sacado \
    shards \
    shylu \
    stokhos \
    stratimikos \
    teko \
    teuchos \
    thyra \
    tpetra \
    trilinoscouplings \
    triutils \
    xpetra \
    zoltan \
    zoltan2

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_TYPE?=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DOC_TRUE=
DOC_FALSE=
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
   DOC_TRUE=\#
else
   DOC_FALSE=\#
endif

%:
	dh $@

clean:
	rm -f *-stamp
	rm -rf debian/tmp_*
	rm -rf packages/*/doc/html
	rm -rf packages/*/browser/doc/html
	rm -rf packages/rtop/src/*/doc/html
	dh clean

override_dh_auto_build-arch:
	dh_auto_build -a --parallel

override_dh_auto_build-indep:
	dh_auto_build -i --parallel

override_dh_auto_configure: configure-stamp

configure-stamp:
	dh_auto_configure -- \
   -DCMAKE_C_COMPILER=mpicc \
   -DCMAKE_CXX_COMPILER=mpicxx \
   -DCMAKE_Fortran_COMPILER=mpif90 \
   -DBUILD_SHARED_LIBS:BOOL=ON \
   -DCMAKE_SKIP_RPATH:BOOL=ON \
   -DTrilinos_LIBRARY_NAME_PREFIX:STRING="trilinos_" \
   -DTrilinos_INSTALL_INCLUDE_DIR:PATH=include/trilinos/ \
   -DTrilinos_USE_GNUINSTALLDIRS:BOOL=ON \
   -DTrilinos_ENABLE_DEVELOPMENT_MODE:BOOL=OFF \
   -DTrilinos_ENABLE_ALL_PACKAGES:BOOL=ON \
   -DTrilinos_ENABLE_SECONDARY_TESTED_CODE:BOOL=ON \
   -DTrilinos_ASSERT_MISSING_PACKAGES:BOOL=OFF \
   -DTrilinos_ENABLE_EXPLICIT_INSTANTIATION:BOOL=ON \
   -DTrilinos_ENABLE_CTrilinos:BOOL=OFF \
   -DTrilinos_ENABLE_FEI:BOOL=OFF \
   -DTrilinos_ENABLE_ForTrilinos:BOOL=OFF \
   -DTrilinos_ENABLE_Gtest:BOOL=OFF \
   -DTrilinos_ENABLE_Mesquite:BOOL=OFF \
   -DTrilinos_ENABLE_MOOCHO:BOOL=OFF \
   -DTrilinos_ENABLE_Optika:BOOL=OFF \
   -DTrilinos_ENABLE_Panzer:BOOL=OFF \
   -DTrilinos_ENABLE_PyTrilinos:BOOL=OFF \
   -DTrilinos_ENABLE_SEACAS:BOOL=OFF \
   -DTrilinos_ENABLE_Sundance:BOOL=OFF \
   -DTrilinos_ENABLE_STK:BOOL=OFF \
   -DTrilinos_ENABLE_STKClassic:BOOL=OFF \
   -DTrilinos_ENABLE_STKDoc_tests:BOOL=OFF \
   -DTrilinos_ENABLE_STKSearch:BOOL=OFF \
   -DTrilinos_ENABLE_STKUnit_tests:BOOL=OFF \
   -DTrilinos_ENABLE_ThreadPool:BOOL=OFF \
   -DTrilinos_ENABLE_EXAMPLES:BOOL=OFF \
   -DTrilinos_ENABLE_TESTS:BOOL=OFF \
   -DTPL_ENABLE_BinUtils:BOOL=OFF \
   -DTPL_ENABLE_Boost:BOOL=ON \
   -DTPL_ENABLE_HDF5:BOOL=ON \
     -DHDF5_INCLUDE_DIRS:PATH=/usr/include/hdf5/openmpi/ \
     -DHDF5_LIBRARY_DIRS:PATH=/usr/lib/$(DEB_HOST_MULTIARCH)/hdf5/openmpi/ \
   -DTPL_ENABLE_Matio:BOOL=OFF \
   -DTPL_ENABLE_MATLAB:BOOL=OFF \
   -DTPL_ENABLE_MPI:BOOL=ON \
   -DTPL_ENABLE_MUMPS:BOOL=ON \
   -DTPL_ENABLE_Netcdf:BOOL=OFF \
   -DTPL_ENABLE_ParMETIS:BOOL=OFF \
   -DTPL_ENABLE_Scotch:BOOL=OFF \
   -DTPL_ENABLE_SuperLU:BOOL=OFF \
   -DTPL_ENABLE_TBB:BOOL=ON \
   -DTPL_ENABLE_X11:BOOL=OFF \
   -DTPL_ENABLE_Zlib:BOOL=ON
	touch $@

BUILDDIR=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)

doc_build-stamp: $(DOC_TRUE)$(LIB_PACKAGES:%=%_doc-stamp)
	touch $@

# ignoring return code. some parts just fail!
$(LIB_PACKAGES:%=%_doc-stamp): %_doc-stamp:
	-cd packages/$*/doc && ./build_docs
	touch $@

override_dh_auto_install-indep: auto_install-indep-stamp
override_dh_auto_install-arch: auto_install-arch-stamp

auto_install-indep-stamp: doc_build-stamp
	mkdir -p $(CURDIR)/debian/tmp_trilinos-doc/usr/share/doc/trilinos;
	for i in $(LIB_PACKAGES); do \
	  echo "cp -r packages/$$i/doc/html/ $(CURDIR)/debian/tmp_trilinos-doc/usr/share/doc/trilinos/$$i"; \
	  cp -r packages/$$i/doc/html/ $(CURDIR)/debian/tmp_trilinos-doc/usr/share/doc/trilinos/$$i || :; \
	done
	touch $@

auto_install-arch-stamp:
	for i in $(LIB_PACKAGES); do \
     if [ -d $(BUILDDIR)/packages/$$i ]; then \
	    $(MAKE) -C $(BUILDDIR)/packages/$$i install DESTDIR=$(CURDIR)/debian/tmp_$$i || exit 1; \
	  else \
	    echo "WARNING: $@, no $$i has been built" >&2; \
       sleep 3; \
	  fi; \
	done
	$(MAKE) -C $(BUILDDIR) install/local DESTDIR=$(CURDIR)/debian/tmp_trilinos-dev
	touch $@

V = $(shell grep -Po 'Trilinos_MAJOR_VERSION \K[\d\.]*' Version.cmake)
MV = $(shell grep -Po 'Trilinos_MAJOR_MINOR_VERSION \K[\d\.]*' Version.cmake)

SOVERSION=$(V)

debian/Trilinos_version.h: debian/Trilinos_version.h.in auto_install-arch-stamp
	test -f $(TV)
	sed -e 's/%V/$(V)/' \
	    -e 's/%MV/$(MV)/' $< > $@

LO_DIR = /usr/share/lintian/overrides

override_dh_install-indep: install-indep-stamp
install-indep-stamp: auto_install-indep-stamp
	@for i in $(LIB_PACKAGES); do \
	  echo "dh_install --sourcedir=debian/tmp_trilinos-doc -ptrilinos-doc --autodest usr/share/ || exit 1;" \
	  dh_install --sourcedir=debian/tmp_trilinos-doc -ptrilinos-doc --autodest usr/share/ || exit 1; \
	done
	dh_install --sourcedir=debian/tmp_trilinos-doc -ptrilinos-doc --autodest usr/share/doc
	if [ ! -d debian/trilinos-doc ]; then \
		echo it should really be there...; \
	fi
	find debian/trilinos-doc -type f -name *.html -print0 | xargs -0 \
		sed -i -e 's_http\(s\|\)://cdn.mathjax.org/mathjax/latest_/usr/share/javascript/mathjax_g' \
		       -e 's#jquery\.js#/usr/share/javascript/jquery/jquery.js#'; \
	find debian/trilinos-doc/usr/share -name jquery.js -delete; \
	touch $@

override_dh_install-arch: install-arch-stamp
install-arch-stamp: SHELL=/bin/bash
install-arch-stamp: auto_install-arch-stamp debian/Trilinos_version.h
	@for i in $(LIB_PACKAGES); do \
     if [ -d $(BUILDDIR)/packages/$$i ]; then \
	    echo "dh_install --sourcedir=debian/tmp_$$i -plibtrilinos-$${i/2/2-}"$(SOVERSION)" usr/lib/*/*.so.*"; \
	    dh_install --sourcedir=debian/tmp_$$i -plibtrilinos-$${i/2/2-}"$(SOVERSION)" usr/lib/*/*.so.* || exit 1; \
	    echo "dh_install --sourcedir=debian/tmp_$$i -plibtrilinos-$$i-dev --autodest usr/include usr/lib/*/*.so usr/lib/*/cmake"; \
	    dh_install --sourcedir=debian/tmp_$$i -plibtrilinos-$$i-dev --autodest usr/include usr/lib/*/*.so usr/lib/*/cmake || exit 1; \
	    if grep -q "^libtrilinos-$$i\>" debian/lintian-override.in; then \
	      install -d debian/libtrilinos-$${i/2/2-}$(SOVERSION)$(LO_DIR); \
	      echo creating $(LO_DIR)/libtrilinos-$${i/2/2-}$(SOVERSION); \
	      grep "^libtrilinos-$${i/2/2-}%V\>" debian/lintian-override.in |\
	        sed -e 's/%V/$(SOVERSION)/g' >\
	        debian/libtrilinos-$${i/2/2-}$(SOVERSION)$(LO_DIR)/libtrilinos-$${i/2/2-}$(SOVERSION); \
	    fi \
	  else \
	    echo "WARNING: $@, no $$i has been built" >&2; \
	  fi; \
	done
	# just check. should not find anything.
	-find debian/lib*-dev -name Trilinos_version.h -print -printf 'BUG, leftover %p'
	for i in `grep -l Trilinos_version\.h debian/lib*-dev/usr/include/trilinos/*ersion*`; do \
		echo fixing header $$i; \
		sed -e '/Trilinos_version/,$$d' $$i > debian/htmp; \
		cat debian/Trilinos_version.h >> debian/htmp; \
		sed -e '1,/Trilinos_version/d' $$i >> debian/htmp; \
		mv debian/htmp $$i; \
	done
	dh_install --sourcedir=debian/tmp_trilinos-dev -ptrilinos-dev --autodest usr/include usr/lib/*/cmake -V foo=bar
	touch $@

override_dh_prep:
	dh_prep
	echo mydevpackages=$(LIB_PACKAGES:%=libtrilinos-%-dev,) > debian/trilinos-all-dev.substvars

override_dh_strip:
	dh_strip --dbgsym-migration='trilinos-dbg (<< 12.6.3-2~)'

.PHONY: override_dh_auto_configure override_dh_auto_install \
	override_dh_install-arch \
	override_dh_install-indep
